<TeXmacs|1.0.1.14>

<style|article>

<\body>
  <\expand|make-title>
    <title|<name|Yacas>: Un entorno de lgebra simblica
    ``hgalo-usted-mismo''>

    <\author>
      Ayal Zwi Pinkus y Serge Winitzki

      traduccin Offray V. Luna Crdenas
    </author>
  </expand>

  <\abstract>
    Describimos el diseo e implementacin de <name|Yacas>, un sistema de
    lgebra computacional libre actualmente en desarrollo. El sistema
    consiste de un intrprete bsico y una librera de <em|scripts> que
    implementa funcionalidad de lgebra simblica. El intrprete provee un
    lenguaje funcional de alto nivel de tipificacin dbil diseado para el
    rpido prototipado de algoritmos de lgebra computacional, pero el
    lenguaje es adecuado para todas las clases de manipulacin simblica.
    Soporta reescritura condicional de trminos de rboles de expresin
    simblica, cerraduras (funciones puras) y evaluacin dilatada, creacin
    dinmica de reglas de transformacin, clculos numricos de precisin
    arbitraria, y sintaxis flexible definida por el usuario empleando
    notacin infija. La biblioteca de <em|scripts> actualmente provee
    funcionalidad bsica de lgebra simblica y numrica, tales como
    polinomios, funciones elementales, lmites, derivadas e integracin
    (limitada), solucin de ecuaciones (simples). Las principales ventajas de
    <name|Yacas> son: software libre (GPL); un lenguaje de programacin
    flexible y fcil de usar con sintaxis confortable y ajustable;
    portabilidad multi-plataforma y pequeos requerimientos de recursos; y
    extensibilidad
  </abstract>

  <\section>
    <value|hrule>

    Introduccin
  </section>

  <name|Yacas> es un Sistema de lgebra Computacional (CAS) que ha sido
  desarrollado desde el comienzo de 1999. La meta era hacer un pequeo
  sistema que permita prototipar e investigar rpidamente algoritmos de
  matemticas simblicas. Una meta secundaria es evolucionar <name|Yacas> en
  un CAS de propsito general [con todos los fierros] [?].

  <name|Yacas> se concebio primariamente para ser una herramienta de
  investigacin para la fcil exploracin y prototipado de algoritmos de
  computacin simblica. La principal ventaja de <name|Yacas> es su rico y
  flexible lenguaje de <em|scripting>. El lenguaje est cercanamente
  relacionado con LISP <with|font series|bold|<with|font family|tt|WH89>>
  pero tiene un analizador gramatical recursivo descendiente para gramtica
  infija <with|font series|bold|<with|font family|tt|ASU86>>, incluye
  transformacin de expresiones (reescritura de trminos), y sporta
  definicin de operadores infijos en tiempo de ejecucin de modo similar a
  \ Prolog <with|font series|bold|<with|font family|tt|B86>>.

  El intrprete del lenguaje <name|Yacas> viene con una biblioteca de
  <em|scripts> que implementan un conjunto de caractersticas de lgebra
  computacional. La biblioteca de <em|scripts> <name|Yacas> est en
  desarrollo activo y en el estado presente no ofrece la rica funcionalidad
  de los sistemas de fortaleza industrial como <name|Mathematica> o
  <name|Maple>. La implementacin extensiva de algoritmos de computacin
  simblica es uno de las metas de desarrollo futuras.

  <name|Yacas> maneja la entrada y la salida en ASCII plano, buen
  interactivamente o en modo <em|batch>. (Una interface grfica est bajo
  desarrollo). Hay tambin un mecanismo de conectores opcionales donde las
  bibliotecas externas pueden ser vinculadas al sistema para proveer
  funcionalidad extra.

  <inactive|<label|c1s2>>

  <\section>
    <value|hrule>

    Diseo bsico
  </section>

  <name|Yacas> consiste de un ``motor base'' (kernel), que es un intrprete
  para el lenguaje de <em|scripting> <name|Yacas>, y una biblioteca de cdigo
  <em|script>.

  El motor de <name|Yacas> ha sido implementado en un subconjunto de C que
  est soportado por casi todos los compiladores de C++. Las metas de diseo
  del motor base son: portabilidad, autocontensin (ninguna dependencia en
  libreras externas o paquetes), facilidad de implementacin de algoritmos,
  transparencia del cdigo y flexibilidad. El sistema <name|Yacas> como un
  todo cae en la categora ``prototipo/hacker'' ms que en la de
  ``axioma/algebrico'', de acuerdo a la terminologa de Fateman <with|font
  series|bold|<with|font family|tt|F90>>. Hay relativamente pocas decisiones
  de diseo especficas relacionadas con las matemticas, pero en cambio el
  enfasis se hace sobre la extensibilidad.

  El kernel ofrece funcionalidad suficientemente rica pero bsica a travs de
  un limitado nmero de funciones base. Esta funcionalidad nuclear incluye
  sustitucin y reescritura de rboles de expresin simblica, analizador
  gramatical de sintaxis infija, y precisin numrica arbitraria. El kernel
  no contiene ninguna definicin de operaciones matemticas simblicas y
  trata de ser tan general y libre como es posible de nociones predefinidas o
  polticas en el dominio de la computacin simblica.

  El mecanismo de interoperabilidad a travs de conectores permite extender
  el kernel de <name|Yacas> o usar libreras externas, ej. <em|toolkits> de
  GUI (Interface Grfica de Usuario, por sus siglas en ingls) o
  implementaciones de algortimos de propsito especial. Una API (Interface de
  Programacin de Aplicaciones, por sus siglas en ingls) es proveida para la
  escritura de ``stubs'' [?] que hagan aparecer las funciones externas en
  <name|Yacas> como nuevas funciones base. Los conectores estn en el mismo
  asentamiento que el kernel de <name|Yacas> y pueden en principio manipular
  todas las estructuras internas de <name|Yacas>. Los conectores pueden ser
  compilados bien se esttica o dinmicamente como bibliotecas compartidas
  para ser cargadas en tiempo de ejecucin por <em|scripts> de <name|Yacas>

  La biblioteca de <em|scripts> contiene declaraciones de reglas de
  transformacin y sintaxis de funciones (prefijas, infijas, etc.). La
  intensin es que todos los algoritmos de manipulacin simblica,
  definiciones de funciones matemticas, etc. deberan ser mantenidas en la
  biblioteca de <em|scripts> y no en el kernel. La nica excepcin hasta
  ahora es para un pequeo nmero de funciones matemticas o de utilidades
  que son frecuentemente usadas; son compiladas en el ncleo por velocidad.

  <\subsection>
    <value|hrule>

    Portabilidad
  </subsection>

  <name|Yacas> est diseado para ser tan independiente respecto a la
  plataforma como sea posible. Todas las partes dependientes de la plataforma
  han sido claramente separadas para facilitar el proceso de portado. Incluso
  la biblioteca estndar de C++ es considerada como especfica respecto a la
  plataforma, pues hay plataformas sin soporte para la biblioteca estndar
  C++ (ej. la plataforma EPOC32).

  La plataforma primaria de desarrollo es GNU/Linux. Actualmente <name|Yacas>
  corre bajo varias variantes de Unix, entornos Windows, organizadores Psion
  (EPOC32), PDAs Ipaq corriendo el kernel Linux, BeOS, y iMacs Apple. Crear
  un ejecutable para otra plataforma (incluyendo plataformas embebidas) no
  debera ser difcil.

  <\subsection>
    <value|hrule>

    Un sistema autocontenido
  </subsection>

  <name|Yacas> debera funcionar como un paquete aislado, requiriendo mnimo
  soporte de otros componentes del sistema operativo. <name|Yacas> toma la
  entrada y la salida en ASCII plano, bien sea interactivamente o en modo
  <em|batch>. (Una interface grfica opcional est bajo desarrollo). El
  sistema viene con su propio mdulo (no optimizado) de precisin aritmtica
  arbitraria pero puede ser compilado usando otra biblioteca de precisin
  aritmtica arbitraria; actualmente el enlace a <verbatim|gmp> es soportado
  experimentalmente. Hay tambin un mecanismo conector adicionald por donde
  las bibliotecas externas pueden ser vinculadas al sistema para proveer
  funcionalidad extra.

  Auto-contencin es un requierimiento si el programa es para ser fcil de
  portar. Una dependencia en bibliotecas que podran no estar disponibles en
  otras plataformar reducira la portabilidad. Por otro lado, <name|Yacas>
  puede ser compilado con un complemento en bibliotecas externas en
  plataformas de "produccin".

  <\subsection>
    <value|hrule>

    Fcil de usar
  </subsection>

  <name|Yacas> es usado principalmente para la ejecucin de programas
  escritos en el lenguaje de <em|script> <name|Yacas>. Una meta de diseo es
  crear un lenguaje de alto nivel que permita al usuario expresar
  convenientemente algoritmos simblicos. Unas pocas lneas de cdigo del
  usuario debern ir bastante lejos.

  Una de las principales ventajas de <name|Yacas> es la flexibilidad de su
  sintaxis. Aunque <name|Yacas> trabaja internamente con un intrprete estilo
  LISP, toda la interaccin del usuario es a travs del leguaje de
  <em|script> <name|Yacas> que tiene una gramtica infija flexible. Los
  operadores infijos son definidos por el usuario y pueden contener
  caracteres no alfabticos tales como "<verbatim|=>" o "<verbatim|#>". Esto
  significa que el usuario puede interactua con <name|Yacas> usando una
  confortable y ajustable sintaxis infija, en lugar de una sintaxis estilo
  LISP. El usuario puede introducir tales convenciones sintcticas como sean
  ms convenientes para un problema dado.

  Por ejemplo, la librera de <em|script> de <name|Yacas> define los
  operadores infijos "<with|font series|bold|<with|font family|tt|+>>",
  "<with|font series|bold|<with|font family|tt|*>>" y as sucesivamente con
  precedencia conveniente, de modo que una expresin algebrica puede ser
  ingresada en la forma familiar infija tal como

  <with|color|blue|<\expand|quote>
    <expand|code*|(x+1)^2 - (y-2*z)/(y+3) + Sin(x*Pi/2)>
  </expand>>

  Una vez que tales operadores infijos son definidos, es posible describir
  nuevas reglas de transformacin directamente usando la nueva sintaxis. Eso
  hace fcil desarrollar procedimientos de simplificacin o evaluacin
  adaptados a un problema particular.

  Suponga que el usuario necesita reordenar exprsiones que contienen
  operadores no conmutativos de creacin y aniquilacin de la teora del
  campo cuntico. Toma cerca de 20 lneas de cdigo <em|script> de
  <name|Yacas> definir una operacin infija "<with|font
  series|bold|<with|font family|tt|**>>" para expersar la multiplicacin no
  conmutativa con las relaciones de conmutacin apropiadas y para ordenar de
  forma normal automticamente todas las expresiones que involucran estos
  smbolos y otros factores conmutativos. Una vez el operador <verbatim|**>
  est definido (con precedencia 4),

  <with|color|blue|<\expand|quote>
    <expand|code*|Infix("**", 4);>
  </expand>>

  las reglas que expresan la distributividad de la operacin <verbatim|**>
  con respecto a la adicin pueden lucir como esto:

  <with|color|blue|<\expand|quote>
    <\expand|code*>
      15 # (_x + _y) ** _z \<less\>-- x ** z + y ** z;

      15 # _z ** (_x + _y) \<less\>-- z ** x + z ** y;
    </expand>
  </expand>>

  Aqu, <verbatim|15 #> es una especificacin de la regla de precedencia,
  <verbatim|_x> denota una variable <verbatim|x> de coincidencia de patrn y
  la expresin a la derecha de <verbatim|\<less\>-> es para ser sustituida en
  lugar de la expresin coincidente en el lado izquierdo. Puesto que todas
  las reglas de transformacin son aplicadas recursivamente, esas dos lneas
  de cdigo son suficienta para el motor de <name|Yacas> para expandir todos
  los parntesis en cualquier expresin conteniendo los operadores infijos
  <verbatim|**> y <verbatim|+>.

  La programacin basada en reglas no es el nico mtodo que puede ser usado
  en los <em|scripts> de <name|Yacas>; hay alternativas que pueden ser ms
  tiles en algunas situaciones. Por ejemplo, los constructos <with|font
  series|bold|<with|font family|tt|if>> / <with|font series|bold|<with|font
  family|tt|else>>, los ciclos <with|font series|bold|<with|font
  family|tt|For>>, <with|font series|bold|<with|font family|tt|ForEach>>
  estn definidos en la biblioteca de <em|script> para la conveniencia de los
  usuarios.

  Los patrones estndar de la programacin prodecimental, tales como
  subrutinas que retornan valores, con bloques de cdigo y variables locales
  temporales, estn tambin disponibles. (Una "subrutina" es implementada
  como un nuevo "trmino fundamental" con una simple regla definida para
  esto). Los usuarios puede libremente combinar reglas con procedimientos
  tipo C or primitivas de procesamiento de listas tipo LISP tales como
  <with|font series|bold|<with|font family|tt|Head()>>, <with|font
  series|bold|<with|font family|tt|Tail()>>.

  <\subsection>
    <value|hrule>

    Claridad del cdigo vs. velocidad
  </subsection>

  La velocidad es obviamente un factor importante. Para <name|Yacas>, donde
  una eleccin tuvo que ser hecha entre velocidad y claridad del cdigo, la
  claridad fue escogida. <name|Yacas> es principalmente un sistema de
  prototipado y su mantenibilidad futura es ms importante.

  Esto significa que sistemas de propsito especial diseados para tipos
  especficos de clculos, como tambin sistemas de lgebra computacional de
  fortaleza industrial intensamente optimizadas, superarn a <name|Yacas>.
  Sin embargo, bibliotecas externas de propsito especial u optimizadas
  pueden ser dinmicamente vinculadas en <name|Yacas> usando un mecanismo
  conector.

  <\subsection>
    <value|hrule>

    Motor flexible, "libre de polticas"
  </subsection>

  El motor ncleo del sistema <name|Yacas> interpreta el lenguaje de
  <em|script> Yacas. La rasn para implementar otro intrprete de lenguaje
  personal basado en LISP en lugar de tomar uno que ya exista fue tener
  control total sobre el sistema y hacerlo autocontenido. Mientras que la
  mayora de las caractersticas en el lenguaje de script de <name|Yacas> son
  el "azucar sintctico" sobre la cima del intrprete LISP, algunas
  caractersticas comunmente no encontradas en sistemas LISP fueron
  adicionadas.

  La biblioteca de <em|script> contiene declaraciones de reglas de
  transformacin y de sintaxis de funciones (prefija, infija, etc.) La
  intensin es que todos los algoritmos de manipulacin simblica,
  definiciones de funciones matemticas y as sucesivamente deberan ser
  mantenidas en la biblioteca de <em|script> y no en el kernel. La nica
  exepcin hasta ahora es para un pequeo nmero de funciones matemticas o
  de utilidades que son frecuentemente usadas; ellas fueron compiladas en el
  nclero por velocidad.

  Por ejemplo, el operador matemtico "<verbatim|+>" es un operador infijo
  definido en la blbioteca de <em|scripts>. Para el kernel, este operador
  esta en la mismo cimiento que cualquier otra funcin definida por el
  usuario y puede ser redefinido. El kernel de <name|Yacas> en s mismo no
  almacena alguna propiedad para este operador. En su lugar este confa
  enteramente en la biblioteca de <em|script> para proveer reglas de
  transformacin para manipular expresiones que involucran el operador
  "<verbatim|+>". En esta forma, el kernel no necesita anticipar todos los
  posibles significados del operador "<verbatim|+>" que en usuario podra
  necesitar es sus clculos.

  Este esquema libre de polticas significa que <name|Yacas> es ltamente
  configurable a travs de su lenguaje de <em|scripting>. Es posible crar un
  enteramente diferente motor de manipulacin simblica basado en el mismo
  kernel C++, con diferente sintaxis y diferentes convenciones de nombres,
  simplemente usando otra biblioteca de <em|script> en lugar de la biblioteca
  de <em|scripts> actual. Un ejemplo de la flexibilidad del sistema
  <name|Yacas> es un <em|script> de ejemplo <verbatim|wordproblems.ys> que
  viene con la distribucin. Este contiene un conjunto de definiciones de
  reglas que hacen que <name|Yacas> reconozca expresiones simples del
  lenguaje Ingls tales como "Tom has 3 apples" o "Jane gave an apple to
  Tom", como expresiones <name|Yacas> vlidas. <name|Yacas> puede entonces
  "evaluar" estas sentencias como <with|font series|bold|<with|font
  family|tt|True>> o <with|font series|bold|<with|font family|tt|False>> de
  acuerdo a la semntica de la situacin actual descrita en ellas.

  El concepto de "libre de polticas" se extiende al tecleo: la tipificacin
  fuerte no es requerida por el kernel, pero puede ser fcilmente forzada por
  los <em|scripts> si es necesario para un problema particular. El lenguaje
  ofrece caracterstica, pero no obliga su uso. Ac hay un ejemplo de una
  poltica implementada en la biblioteca de <em|scripts>:

  <with|color|blue|<\expand|quote>
    <\expand|code*>
      61 # x_IsPositiveNumber ^ y_IsPositiveNumber\ 

      \ \ \ \ \ \ \<less\>-- MathPower(x,y);
    </expand>
  </expand>>

  Por esta regla, expresiones de la forma <with|font series|bold|<with|font
  family|tt|x^y>> (representado la potencia <with|mode|math|x<rsup|y>>) son
  evaluadas y reemplazadas por un nmero si y slo si <verbatim|x> y
  <verbatim|y> son constantes numricas positivas. (La funcin <with|font
  series|bold|<with|font family|tt|MathPower>> est definida en el kernel).
  Si la simplificacin por defecto no es deseable, el usuario podra borrar
  la regla de la biblioteca y tener un CAS sin esta caracterstica.

  <\section>
    <value|hrule>

    La funcionalidad del kernel de <name|Yacas>
  </section>

  <name|Yacas> <em|script> es un lenguaje funcional basado en varias ideas
  que parecen tiles para la implmentacin de un CAS: estructuras de datos
  basadas en listas, propiedades de objetos, y programacin funcional (a la
  LISP); reescritura de trminos [BN98] con coincidencia de patrones algo
  [along] [?] las lneas de <name|Mathematica>; operadores infijos definidos
  por el usuario a la <name|Prolog>; evaluacin demorada de expresiones; y
  aritmtica de precisin arbitrria. La recoleccin de basura es
  implementada a travs del conteo de referencia.

  El kernel provee tres tipos de datos bsicos: nmeros, cadenas, y tomos, y
  dos tipos cotenedores: listas y arreglos estticos (por velocidad). Los
  tomos son implementados como cadenas que pueden ser valores asignados y
  evaluados. Los valores Booleanos son simplementa tomos <with|font
  series|bold|<with|font family|tt|True>> y <with|font series|bold|<with|font
  family|tt|False>>. Los rboles de expresin, tablas asociativas (hash),
  pilas, y cerraduras (funciones puras) son todas implementadas usando listas
  anidadas. En adicin, ms tipos de datos pueden ser provedos por
  conectores. Las primitivas del Kernel estn disponibles para aritmtica de
  precisin arbitraria, manipulacin de cadenas, acceso y manipulacin de
  listas y arreglos, control de flujo bsico, asignacin de variables
  (tomos) y para definir \ reglas para funciones (tomos con sintaxis de
  funcin).

  El motor intrprete recursivamente evalua rboles de expresin de acuerdo a
  reglas de transformacin definidas por el usuario desde la biblioteca de
  <em|script>. La evaluacin procede de abajo hacia arriba, esto es, para
  cada trmino de una funcin, los argumentos son evaluados primero y luego
  la funcin.

  Una primitiva <with|font family|tt|HoldArg()> es proveida para no evaluar
  ciertos argumentos de ciertas funciones antes de pasarlos como parmetros a
  esas funciones. Las primitivas <with|font series|bold|<with|font
  family|tt|Hold()>> y <with|font series|bold|<with|font family|tt|Eval()>>,
  de modo similar a los <with|font series|bold|<with|font family|tt|QUOTE>> y
  <with|font series|bold|<with|font family|tt|EVAL>> de LISP, pueden ser
  usadas para detener la aplicacin recursiva de reglas en cierto punto y
  obtener una expresin no evaluada, o para iniciar la evaluacin de una
  expresin que ha sido mantenida previamente sin evaluar.

  Cuando una expresin no puede ser transformada ms, esto es, cuando ms
  reglas no se aplican a ella, la expresin es retornada no evaluada. Por
  ejemplo, una variable a la que no est asignado un valor ser retornada sin
  evaluar. Este es un comportamiento deseado en un sistema de manipulacin
  simblica.

  Las reglas son comparadas por una expresin patrn que puede contener
  <em|variables patrn>, es decir, tomos marcados por el operador
  "<with|font series|bold|<with|font family|tt|_>>". Durante la comparacin,
  cada variable patrn se convierte en una variable local y es tentativamente
  asignada a la subexpresin que est siendo comparada. Por ejemplo, el
  patrn <with|font series|bold|<with|font family|tt|_x + _y>> puede
  igualarse a una expresin <with|font series|bold|<with|font
  family|tt|a*x+b>> y entonces la variable patrn <var|x> ser asignada a
  <with|font series|bold|<with|font family|tt|a*x>> (sin evaluar) y la
  variable <var|y> ser asignada al valor <var|b>.

  Este tipo de igualacin semntica ha sido frecuentemente implementado antes
  en varios sistemas de reescritura de trminos (ver por ej. [C86]). Sin
  embargo, el lenguaje <name|Yacas> ofrece a sus usuarios una habilidad para
  crear un mucho ms flexible y poderosos sistema de reescritura de trminos
  que uno basado en un conjunto fijo de reglas. Aqu estn algunas
  caractersticas:

  Primero, las reglas de transformacin en <name|Yacas> tiene predicados que
  controlan cuando una regla debera ser aplicada a una expresin. Los
  predicados pueden ser cualquier expresin <name|Yacas> que evalue a los
  tomos <with|font series|bold|<with|font family|tt|True>>  <with|font
  series|bold|<with|font family|tt|False>> y son tpicamente funciones de
  variables patrn. Un predicado puede chequear los tipos o valores de
  ciertas subexpresiones del contexto de igualacin (vea el ejemplo
  <with|font series|bold|<with|font family|tt|_x ^ _y>> en la subseccin
  previa)

  Segundo, las reglas son asignadas con un valor de precedencia (un entero
  positivo) que controla el orden de las reglas a ser intentadas. As
  <name|Yacas> provee algn mejor control sobre la recursin automtica que
  los sistemas de igualacin de patrones de <name|Mathematica> que no permite
  precedencia de reglas. El intrprete primero aplicar la regla que coincida
  con el patrn argumento, para el cual el predicado retorne <with|font
  series|bold|<with|font family|tt|True>>, y que tenga la menor precedencia.

  Tercero, las nuevas reglas pueden ser definidas dinmicamente como un
  efecto lateral de la evaluacin. Esto significa que no hay un "alfabeto
  posicionado" o "trminos de base" predefinidos (en la terminologa de
  [TATA99]), en otras palabras, ningn conjunto fijo de funciones con
  aridades predefinidas. Es tambin posible definir una "regla clausurativa"
  que define reglas dependiendo de sus argumentos, o borrar reglas. Asi, una
  biblioteca de <em|scripts> <name|Yacas> (aunque es de slo lectura) no
  representa un autmata de reescritura fija de rboles. Una implementacin
  de una mquina de aprendizaje es posible en <name|Yacas> (entre otras
  cosas). Por ejemplo, cuando el mdulo <verbatim|wordproblems.ys>
  (mencionado en la subseccin previa) "aprende" que la entrada de usuario
  <verbatim|manzana> es un objeto contable, este define un nuevo operador
  postfijo <verbatim|manzanas> y una regla para su evaluacin, as que la
  expresin <verbatim|3 manzanas> es luego analizada gramaticalmente como una
  funcin <verbatim|manzanas(3)> y evaluada de acuerdo a la regla.

  Cuarto, las subexpresiones <name|Yacas> pueden ser "etiquetadas" (asignadas
  a un "objeto propiedad" a la LISP) y las etiquetas pueden ser chequeadas
  por predicados en reglas o usadas en la evaluacin.

  Quinto, el alcance de las variables puede ser controlado. En adicin a
  tener sus propias variables locales, a una funcin se le puede permitir
  acceder a variables locales de su entorno de llamado (la primitiva
  <with|font family|tt|UnFence()>). Es tambin posible encapsular un grupo de
  variables y funciones en un "mdulo", haciendo algunas de ellas
  inaccesibles desde afuera (la primitiva <with|font
  family|tt|LocalSymbols()>). El alcance de las variables es una "decisin
  poltica", para ser forzada por el <em|script> que define esa funcin. Esta
  flexibilidad es por diseo y permite fcilmente modificar el comportamiento
  del intrprete, efectivamente cambiando el lenguaje como sea necesario.

  <\section>
    <value|hrule>

    El \ lenguaje de <em|scripting> <name|Yacas>
  </section>

  El intrprete <name|Yacas> es suficientemente poderoso que las funciones
  \ <with|font series|bold|<with|font family|tt|While>>, <with|font
  series|bold|<with|font family|tt|For>>, <with|font series|bold|<with|font
  family|tt|ForEach>>, <with|font series|bold|<with|font family|tt|if>>,
  <with|font series|bold|<with|font family|tt|else>> etc., as como el
  conveniente atajo "...<with|font series|bold|<with|font
  family|tt|\<less\>-->>..." para la definicin de nuevas reglas pueden ser
  definidos en la librera de <em|scripts> en s misma en lugar de en el
  kernel. Este poder es dado totalmente al usuario, puesto que la librera de
  <em|scripts> est en la misma base que cualquier cdigo definido por el
  usuario. Algunas bibliotecas de funciones son concebidas principalmente
  como herramientas disponibles al usuario de <name|Yacas> para hacer la
  implementacin de algoritmos ms confortable. Abajo hay algunos ejemplos de
  caractersticas provistas por el lenguaje de <em|scripting> <name|Yacas>.

  <name|Yacas> soporta "sobrecarga de funciones": permite al usuario declarar
  funciones <with|font series|bold|<with|font family|tt|f(x)>> y <with|font
  series|bold|<with|font family|tt|f(x,y)>>, cada una teniendo su propio
  conjunto de reglas de transformacin. Por supuesto, reglas diferentes
  pueden ser definidas para funciones con el mismo nombre con el mismo nmero
  de argumentos (aridad) pero con diferentes patrones de argumentos o
  diferentes predicados.

  Transformaciones simples sobre expresiones pueden ser realizadas usando
  reglas. Por ejemplo, si necesitamos expandir el logaritmo natural en una
  expresin, podramos usar las siguientes reglas:

  <\session|yacas|default>
    \;

    <\input|yacas] >
      log(_x * _y) \<less\>-- log(x) + log(y);
    </input>

    <\output>
      <\with|mode|math>
        <with|math font family|rm|True >
      </with>
    </output>

    <\input|yacas] >
      log(_x ^ _n) \<less\>-- n * log(x);
    </input>

    <\output>
      <\with|mode|math>
        <with|math font family|rm|True >
      </with>
    </output>

    \;
  </session>

  Estas dos reglas definen una nueva funcin simblica <verbatim|log> que no
  ser evaluada sino slo transformada si una de esas dos reglas es
  aplicable. El smbolo <with|font series|bold|<with|font family|tt|_>>, como
  antes, indica que el siguiente tomo es una variable patrn que iguala
  subexpresiones.

  Despus de entrar esas dos reglas, la siguiente sesin interactiva es
  posible:

  <\session|yacas|default>
    <\input|yacas] >
      log(a*x^2)
    </input>

    <\output>
      <\with|mode|math>
        <with|math font family|rm|log ><left|(>a<right|)>+2<with|math font
        family|rm|log ><left|(>x<right|)>
      </with>
    </output>

    \;
  </session>

  La integracin de una nueva funcin <verbatim|log> puede ser definida
  adicionando una regla para el tomo de la funcin <verbatim|AntiDeriv>,

  <\session|yacas|default>
    <\input|yacas] >
      AntiDeriv(_x,log(_x)) \<less\>-- x*log(x)-x;
    </input>

    <\output>
      <\with|mode|math>
        <with|math font family|rm|True >
      </with>
    </output>

    \;
  </session>

  Ahora <name|Yacas> puede hacer integraciones que involucren la nueva
  funcin definida <verbatim|log>, por ejemplo:

  <\session|yacas|default>
    <\input|yacas] >
      Integrate(x)log(a*x^n)
    </input>

    <\output>
      <\with|mode|math>
        <with|math font family|rm|log ><left|(>a<right|)>x+n<left|(>x<with|math
        font family|rm|log ><left|(>x<right|)>-x<right|)>
      </with>
    </output>

    <\input|yacas] >
      Integrate(x,B,C)log(a*x^n)
    </input>

    <\output>
      <\with|mode|math>
        <with|math font family|rm|log ><left|(>a<right|)>C+n<left|(>C<with|math
        font family|rm|log ><left|(>C<right|)>-C<right|)>-<left|(><with|math
        font family|rm|log ><left|(>a<right|)>B+n<left|(>B<with|math font
        family|rm|log ><left|(>B<right|)>-B<right|)><right|)>
      </with>
    </output>

    \;
  </session>

  Las reglas son aplicadas cuando sus patrones asociados coinciden y cuando
  sus predicados retornan <with|font family|tt|True>. Las reglas tambin
  tiene precedencia, un valor entero para indicar cuales reglas necesitan ser
  aplicadas primero. Usando estas caractersticas, una implementacin
  recursiva de el factorial entero puede lucir como esto en el <em|script> de
  <name|Yacas>,\ 

  <\expand|quote>
    <with|color|blue|<\expand|code*>
      10 # Factorial(_n) _ (n=0) \<less\>-- 1;

      20 # Factorial(n_IsInteger) _ (n\<gtr\>0) \<less\>--

      \ \ n*Factorial(n-1);
    </expand>>
  </expand>

  Ac las reglas tienen precedencia 10 y 20, as que las primera regla ser
  tratada primero y la recursin se detendr cuando <with|mode|math|n=0> sea
  alcanzado.

  Rule-based programming can be freely combined with procedural programming
  when the latter is a more appropriate method. For example, here is a
  function that computes (<with|font series|bold|Mod(x^n,m)>) efficiently:

  La programacin basada en reglas puede ser lbremente combinada con
  programacin procedimental cuando la ltima es un mtodo ms apropiado. Por
  ejemplo, ac hay una funcin que computa
  (<with|mode|math|Mod(x<rsup|n>,m)>) eficientemente:\ 

  <with|color|blue|<\expand|quote>
    <\expand|code*>
      powermod(x_IsPositiveInteger, n_IsPositiveInteger,

      \ \ \ \ m_IsPositiveInteger) \<less\>--

      [

      \ \ Local(result);

      \ \ result:=1;

      \ \ x:=Mod(x,m);

      \ \ While(n != 0)

      \ \ [

      \ \ \ \ if ((n&1) = 1)

      \t[

      \ \ \ \ \ \ result := Mod(result*x,m);

      \ \ \ \ ];

      \ \ \ \ x := Mod(x*x,m);

      \ \ \ \ n := n\<gtr\>\<gtr\>1;

      \ \ ];

      \ \ result;

      ];
    </expand>
  </expand>>

  La interaccin con la funcin <with|font family|tt|powermod(x,n,m)> lucira
  entonces como esto:

  <with|color|blue|<\expand|quote>
    <\expand|code*>
      In\<gtr\> powermod(2,10,100)

      Out\<gtr\> 24;

      In\<gtr\> Mod(2^10,100)

      Out\<gtr\> 24;

      In\<gtr\> powermod(23234234,2342424234,232423424)

      Out\<gtr\> 210599936;
    </expand>
  </expand>>

  <inactive|<label|c1s5>>

  <\section>
    <value|hrule>

    Caratersticas CAS actualmente suportadas
  </section>

  <name|Yacas> consiste de aproximadamente 22000 lnes de cdigo C++ y 13000
  lneas de cdigo de <em|scripting>, con 170 funciones definidas en el
  kernel C++ y 600 funciones definidas en el lenguaje de <em|scripting>.
  Estos nmeros son engaosamente pequeos. El programa est escrito en un
  limpio y sencillo estilo para conservarlo mantenible. La optimizacin
  excesiba tiende a hinchar el software y lo hace menos legible.

  Una base de capacidades matemticas han sido ya implementadas en la
  biblioteca de <em|scripts> (las fuentes de inspiracin primarias fueron los
  libros [K98], [GG99] y [B86]). La biblioteca de <em|scripts> est
  actualmente bajo activo desarrollo. La siguiente seccin demuestra algunas
  facilidades ya ofrecidas en el sistema actual.

  Operaciones bsicas de clculo elemental han sido implementadas:

  <\session|yacas|defaul>
    \;

    <\input|yacas] >
      Limit(n,Infinity)(1+(1/n))^n
    </input>

    <\output>
      <\with|mode|math>
        exp <left|(>1<right|)>
      </with>
    </output>

    <\input|yacas] >
      Limit(h,0) (Sin(x+h)-Sin(x))/h
    </input>

    <\output>
      <\with|mode|math>
        cos x
      </with>
    </output>

    <\input|yacas] >
      Taylor(x,0,5)ArcSin(x)
    </input>

    <\output>
      <\with|mode|math>
        x+<frac|x<rsup|3>|6>+<frac|3x<rsup|5>|40>
      </with>
    </output>

    <\input|yacas] >
      InverseTaylor(x,0,5)Sin(x)
    </input>

    <\output>
      <\with|mode|math>
        <frac|3x<rsup|5>|40>+<frac|x<rsup|3>|6>+x
      </with>
    </output>

    <\input|yacas] >
      Integrate(x,a,b)Ln(x)+x
    </input>

    <\output>
      <\with|mode|math>
        b*ln b-b+<frac|b<rsup|2>|2>-<left|(>a*ln
        a-a+<frac|a<rsup|2>|2><right|)>
      </with>
    </output>

    <\input|yacas] >
      Integrate(x)1/(x^2-1)
    </input>

    <\output>
      <\with|mode|math>
        <frac|ln 2<left|(>x-1<right|)>|2>-<frac|ln 2<left|(>x+1<right|)>|2>
      </with>
    </output>

    <\input|yacas] >
      OdeSolve(y''==4*y)
    </input>

    <\output>
      <\with|mode|math>
        C<rsub|33>exp <left|(>-2x<right|)>+C<rsub|35>exp <left|(>2x<right|)>
      </with>
    </output>

    \;
  </session>

  Resolucin de sistemas de ecuaciones han sido implementadas usando un
  sistema generalizado de eliminacin Gaussiana:

  <\session|yacas|default>
    \;

    <\input|yacas] >
      Solve( {x+y+z==6, 2*x+y+2*z==10, x+3*y+z==10}, {x,y,z}) [1]
    </input>

    <\output>
      <\with|mode|math>
        <left|(>4-z,2,z<right|)>
      </with>
    </output>

    \;
  </session>

  (La solucin a este sistema indeterminado es retornada como un vector, as
  que <with|mode|math|x=4-z>, <with|mode|math|y=2>, y <with|mode|math|z>
  permanece arbitraria).

  Un pequeo probador de teoremas [B86] usando el principio de resolucin es
  ofrecido:

  <\session|yacas|default>
    <\input|yacas] >
      CanProve(P Or (Not P And Not Q))
    </input>

    <\output>
      <\with|mode|math>
        \<neg\>Q\<vee\>P
      </with>
    </output>

    <\input|yacas] >
      CanProve(a \<gtr\> 3 And a \<less\> 2)
    </input>

    <\output>
      <\with|mode|math>
        <with|math font family|rm|False >
      </with>
    </output>
  </session>

  Varios algortimos numricos de precisin arbitraria han sido implementados:

  <\session|yacas|default>
    <\input|yacas] >
      N(1/7,40); \ \ \ // evalua a 40 digitos
    </input>

    <\output>
      <\with|mode|math>
        0.1428571428571428571428571428571428571428
      </with>
    </output>

    <\input|yacas] >
      Decimal(1/7); \ \ \ // obtiene el periodo decimal
    </input>

    <\output>
      <\with|mode|math>
        <left|(>0,<left|(>1,4,2,8,5,7<right|)><right|)>
      </with>
    </output>

    <\input|yacas] >
      N(LnGamma(1.234+2.345*I)); \ \ \ // funcion gamma
    </input>

    <\output>
      <\with|mode|math>
        0.70978922847119\<imath\>-2.1325569112
      </with>
    </output>

    \;
  </session>

  Varios simplificadores de expresiones de dominio especfico estn
  disponibles:

  <\session|yacas|default>
    <\input|yacas] >
      RadSimp(Sqrt(9+4*Sqrt(2)))
    </input>

    <\output>
      <\with|mode|math>
        <sqrt|8>+1
      </with>
    </output>

    <\input|yacas] >
      TrigSimpCombine(Sin(x)^2+Cos(x)^2)
    </input>

    <\output>
      <\with|mode|math>
        1
      </with>
    </output>

    <\input|yacas] >
      TrigSimpCombine(Cos(x/2)^2-Sin(x/2)^2)
    </input>

    <\output>
      <\with|mode|math>
        cos x
      </with>
    </output>

    <\input|yacas] >
      GcdReduce((x^2+2*x+1)/(x^2-1),x)
    </input>

    <\output>
      <\with|mode|math>
        <frac|x+1|x-1>
      </with>
    </output>

    \;
  </session>

  Polinomios univariados son soportados en representacin densa, y polinomios
  multivariados en representacin dispersa:

  <\session|yacas|default>
    <\input|yacas] >
      Factor(x^6+9*x^5+21*x^4-5*x^3-54*x^2-12*x+40)
    </input>

    <\output>
      <\with|mode|math>
        <left|(>x+2<right|)><rsup|3><left|(>x-1<right|)><rsup|2><left|(>x+5<right|)>
      </with>
    </output>

    <\input|yacas] >
      Apart(1/(x^2-x-2))
    </input>

    <\output>
      <\with|mode|math>
        <frac|1|3<left|(>x-2<right|)>>-<frac|1|3<left|(>x+1<right|)>>
      </with>
    </output>

    <\input|yacas] >
      Together(%)
    </input>

    <\output>
      <\with|mode|math>
        <frac|9|9x<rsup|2>-9x-18>
      </with>
    </output>

    <\input|yacas] >
      Simplify(%)
    </input>

    <\output>
      <\with|mode|math>
        <frac|1|x<rsup|2>-x-2>
      </with>
    </output>

    \;
  </session>

  Varias funciones de "endulce sintctico" han sido definidas para entrar
  expresiones ms fcilmente:

  <\session|yacas|default>
    <\input|yacas] >
      Ln(x*y) /: { Ln(_a*_b) \<less\>- Ln(a) + Ln(b) }
    </input>

    <\output>
      <\with|mode|math>
        ln x+ln y
      </with>
    </output>

    <\input|yacas] >
      Sum(x^(1 .. 5))
    </input>

    <\output>
      <\with|mode|math>
        <with|math font family|rm|Sum ><left|(><expand|tabular*|<tformat|<cwith|1|-1|1|1|cell
        halign|c>|<cwith|1|-1|2|2|cell halign|c>|<cwith|1|-1|3|3|cell
        halign|c>|<cwith|1|-1|4|4|cell halign|c>|<cwith|1|-1|5|5|cell
        halign|c>|<table|<row|<cell|x>|<cell|x<rsup|2>>|<cell|x<rsup|3>>|<cell|x<rsup|4>>|<cell|x<rsup|5>>>>>><right|)>
      </with>
    </output>

    <\input|yacas] >
      Select("IsPrime", 1 .. 15)
    </input>

    <\output>
      <\with|mode|math>
        <left|(>2,3,5,7,11,13<right|)>
      </with>
    </output>

    \;
  </session>

  Las bases de Groebner [GG99] han sido implementadas:

  <\session|yacas|default>
    <\input|yacas] >
      Groebner({x*(y-1),y*(x-1)})
    </input>

    <\output>
      CommandLine(1) : Predicate doesn't evaluate to a boolean in pattern
    </output>

    \;
  </session>

  (From this it follows that <with|mode|math|x=y>, and <with|mode|math|x^2=x>
  so <with|mode|math|x> is <with|mode|math|0> or <with|mode|math|1>.)

  (De esto se sigue que <with|mode|math|x=y>, and
  <with|mode|math|x<rsup|2>=x> as <with|mode|math|x> es <with|mode|math|0> o
  <with|mode|math|1>).

  Matrices inversas simblicas:

  <\session|yacas|default>
    <\input|yacas] >
      Inverse({{a,b},{c,d}})
    </input>

    <\output>
      <\with|mode|math>
        <left|(><expand|tabular*|<tformat|<cwith|1|-1|1|1|cell
        halign|c>|<cwith|1|-1|2|2|cell halign|c>|<table|<row|<cell|<frac|d|a*d-b*c>>|<cell|<frac|-b|a*d-b*c>>>|<row|<cell|<frac|-c|a*d-b*c>>|<cell|<frac|a|a*d-b*c>>>>>><right|)>
      </with>
    </output>

    \;
  </session>

  Esta lista de caractersticas no es exhaustiva.

  <inactive|<label|c1s6>>

  <\section>
    <value|hrule>

    Interface
  </section>

  Actualmente <name|Yacas> es primariamente una aplicacin orientada al texto
  con una interface interactiva a travs de la consola de texto. Los comandos
  son ingresados y evaluados lnea por lnea; los archivos que contienen un
  cdigo ms largo pueden ser cargados y evaluados. Una interface
  "<em|notebook>" bajo el editor GNU Emacs y <TeXmacs> estn disponibles. Hay
  tambin una interface grfica experimental (<with|font
  series|bold|<with|font family|tt|proteus>>) para entornos Unix y Windows.

  Facilidades de depuracin estn implementadas, permitiendo trazar la
  ejecucin de una funcin, aplicacin de un trazo a una regla de patrn
  dada, o examinar la pila cuando la recursin no ha terminado. Una versin
  experimental del depurador del ejecutable de <name|Yacas> \ que provee
  informacin ms detallada puede ser compilado.<label|c1s7>

  <\section>
    <value|hrule>

    Documentacin
  </section>

  La documentacin para <name|Yacas> es extensiva y es actualizada
  activamente, siguiendo el desarrollo del sistema. La documentacin
  actualmente consiste de dos guas tutoriales (la introduccin del usuario y
  la introduccin de programador), una coleccin de ensayos que describen
  algunas caractersticas avanzadas en mayor detalle y un completo manual de
  referencia.

  <name|Yacas> actualmente viene con su propio module de formateo de
  documentos que permite mantener la documentacin en un formata especial de
  texto plano con etiquetamiento mnimo. Este formato de texto es
  automticamente convertido a formatos HTML, <LaTeX>, PostScript y PDF. La
  versin HTML del documento est hipervinculada y est disponible desde el
  <em|prompt> de <name|Yacas>

  <inactive|<label|c1s8>>

  <\section>
    <value|hrule>

    Planes futuros
  </section>

  El plan a largo plazo para <name|Yacas> es convertirse en un CAS de
  fortaleza industrial y mantenerse como una herramienta de investigacin
  flexible para fcil prototipado de varios mtodos de clculos simblicos.
  <name|Yacas> se destino para ser un repotorio y un <em|testbed> para tales
  prototipos de algoritmos.

  <label|c1s9>La facilidad del conector ser extendida en el futuro, de modo
  que un rico conjunto de bibliotecas adicionales extra (especialmente
  bibliotecas de software libre), especficas para el sistema as como
  tambin orientadas a las matemticas, seran cargadas desde el sistema
  <name|Yacas>. El aspecto de la velocidad est tambin constantemente siendo
  manejado.

  <\section>
    <value|hrule>

    Referencias
  </section>

  [ASU86] A. Aho, R. Sethi and J. Ullman, <with|font shape|italic|Compilers
  (Principles, Techniques and Tools)>, Addison-Wesley, 1986.

  [B86] I. Bratko, <with|font shape|italic|Prolog (Programming for Artificial
  Intelligence)>, Addison-Wesley, 1986.

  [BN98] F. Baader and T. Nipkow, <with|font shape|italic|Term rewriting and
  all that>, Cambridge University Press, 1998.

  [C86] G. Cooperman, <with|font shape|italic|A semantic matcher for computer
  algebra>, in Proceedings of the symposium on symbolic and algebraic
  computation (1986), Waterloo, Ontario, Canada (ACM Press, NY).

  [F90] R. Fateman, <with|font shape|italic|On the design and construction of
  algebraic manipulation systems>, also published as: ACM Proceedings of the
  IAC-90, Tokyo, Japan.

  [GG99] J. von zur Gathen and J. Gerhard, <with|font shape|italic|Modern
  Computer Algebra>, Cambridge University Press, 1999.

  [K98] D. Knuth, <with|font shape|italic|The Art of Computer Programming
  (Volume 2, Seminumerical Algorithms)>, Addison-Wesley, 1998.

  [TATA99] H. Comon, M. Dauchet, R. Gilleron, F. Jacquemard, D. Lugiez, S.
  Tison, and M. Tommasi, <with|font shape|italic|Tree Automata Techniques and
  Applications>, 1999, online book: <hlink|http://www.grappa.univ-lille3.fr/tata|http://www.grappa.univ-lille3.fr/tata>

  [W96] S. Wolfram, <with|font shape|italic|The Mathematica book>, Wolfram
  Media, Champain, 1996.

  [WH89] P. Winston and B. Horn, <with|font shape|italic|LISP>,
  Addison-Wesley, 1989.
</body>

<\initial>
  <\collection>
    <associate|paragraph width|150mm>
    <associate|odd page margin|5mm>
    <associate|page medium|automatic>
    <associate|interparagraph space|5sep>
    <associate|page right margin|5mm>
    <associate|page top margin|5mm>
    <associate|reduction page right margin|25mm>
    <associate|reduction page bottom margin|15mm>
    <associate|first indentation|0>
    <associate|even page margin|5mm>
    <associate|reduction page left margin|25mm>
    <associate|page height|956160unit>
    <associate|page bottom margin|5mm>
    <associate|reduction page top margin|15mm>
    <associate|page width|1272320unit>
    <associate|language|spanish>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|toc-10|<tuple|5|?>>
    <associate|toc-11|<tuple|6|?>>
    <associate|toc-12|<tuple|7|?>>
    <associate|toc-13|<tuple|8|?>>
    <associate|toc-14|<tuple|9|?>>
    <associate|toc-15|<tuple|9|?>>
    <associate|toc-16|<tuple|9|?>>
    <associate|toc-17|<tuple|9|?>>
    <associate|c1|<tuple|<uninit>|?>>
    <associate|c1s1|<tuple|<uninit>|?>>
    <associate|toc-1|<tuple|1|?>>
    <associate|c1s2|<tuple|1|?>>
    <associate|toc-2|<tuple|2|?>>
    <associate|toc-3|<tuple|2.1|?>>
    <associate|c1s3|<tuple|2.5|?>>
    <associate|c1s4|<tuple|3|?>>
    <associate|toc-4|<tuple|2.2|?>>
    <associate|toc-5|<tuple|2.3|?>>
    <associate|c1s5|<tuple|4|?>>
    <associate|toc-6|<tuple|2.4|?>>
    <associate|c1s6|<tuple|5|?>>
    <associate|toc-7|<tuple|2.5|?>>
    <associate|c1s7|<tuple|6|?>>
    <associate|toc-8|<tuple|3|?>>
    <associate|c1s8|<tuple|7|?>>
    <associate|toc-9|<tuple|4|?>>
    <associate|c1s9|<tuple|8|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <vspace*|1fn><with|font series|<quote|bold>|math font
      series|<quote|bold>|1<space|2spc><format|no first
      indentation><tformat|<tformat|<cwith|1|-1|1|-1|cell
      tborder|1ln>|<twith|table width|1par>|<cwith|1|-1|1|-1|cell
      vmode|exact>|<cwith|1|-1|1|-1|cell height|1ln>|<cwith|1|-1|1|-1|cell
      lsep|0fn>|<cwith|1|-1|1|-1|cell rsep|0fn>|<cwith|1|-1|1|-1|cell
      bsep|0fn>|<cwith|1|-1|1|-1|cell tsep|0fn>|<cwith|1|-1|1|-1|cell
      vcorrect|n>|<table|<row|<cell|<space|1fn|0ln|1ln>>>>>>

      Introduccin><value|toc-dots><pageref|toc-1><vspace|0.5fn>

      <vspace*|1fn><with|font series|<quote|bold>|math font
      series|<quote|bold>|2<space|2spc><format|no first
      indentation><tformat|<tformat|<cwith|1|-1|1|-1|cell
      tborder|1ln>|<twith|table width|1par>|<cwith|1|-1|1|-1|cell
      vmode|exact>|<cwith|1|-1|1|-1|cell height|1ln>|<cwith|1|-1|1|-1|cell
      lsep|0fn>|<cwith|1|-1|1|-1|cell rsep|0fn>|<cwith|1|-1|1|-1|cell
      bsep|0fn>|<cwith|1|-1|1|-1|cell tsep|0fn>|<cwith|1|-1|1|-1|cell
      vcorrect|n>|<table|<row|<cell|<space|1fn|0ln|1ln>>>>>>

      Diseo bsico><value|toc-dots><pageref|toc-2><vspace|0.5fn>

      2.1<space|2spc><format|no first indentation><tformat|<tformat|<cwith|1|-1|1|-1|cell
      tborder|1ln>|<twith|table width|1par>|<cwith|1|-1|1|-1|cell
      vmode|exact>|<cwith|1|-1|1|-1|cell height|1ln>|<cwith|1|-1|1|-1|cell
      lsep|0fn>|<cwith|1|-1|1|-1|cell rsep|0fn>|<cwith|1|-1|1|-1|cell
      bsep|0fn>|<cwith|1|-1|1|-1|cell tsep|0fn>|<cwith|1|-1|1|-1|cell
      vcorrect|n>|<table|<row|<cell|<space|1fn|0ln|1ln>>>>>>

      Portabilidad<value|toc-dots><pageref|toc-3>

      2.2<space|2spc><format|no first indentation><tformat|<tformat|<cwith|1|-1|1|-1|cell
      tborder|1ln>|<twith|table width|1par>|<cwith|1|-1|1|-1|cell
      vmode|exact>|<cwith|1|-1|1|-1|cell height|1ln>|<cwith|1|-1|1|-1|cell
      lsep|0fn>|<cwith|1|-1|1|-1|cell rsep|0fn>|<cwith|1|-1|1|-1|cell
      bsep|0fn>|<cwith|1|-1|1|-1|cell tsep|0fn>|<cwith|1|-1|1|-1|cell
      vcorrect|n>|<table|<row|<cell|<space|1fn|0ln|1ln>>>>>>

      Un sistema autocontenido<value|toc-dots><pageref|toc-4>

      2.3<space|2spc><format|no first indentation><tformat|<tformat|<cwith|1|-1|1|-1|cell
      tborder|1ln>|<twith|table width|1par>|<cwith|1|-1|1|-1|cell
      vmode|exact>|<cwith|1|-1|1|-1|cell height|1ln>|<cwith|1|-1|1|-1|cell
      lsep|0fn>|<cwith|1|-1|1|-1|cell rsep|0fn>|<cwith|1|-1|1|-1|cell
      bsep|0fn>|<cwith|1|-1|1|-1|cell tsep|0fn>|<cwith|1|-1|1|-1|cell
      vcorrect|n>|<table|<row|<cell|<space|1fn|0ln|1ln>>>>>>

      Fcil de usar<value|toc-dots><pageref|toc-5>

      2.4<space|2spc><format|no first indentation><tformat|<tformat|<cwith|1|-1|1|-1|cell
      tborder|1ln>|<twith|table width|1par>|<cwith|1|-1|1|-1|cell
      vmode|exact>|<cwith|1|-1|1|-1|cell height|1ln>|<cwith|1|-1|1|-1|cell
      lsep|0fn>|<cwith|1|-1|1|-1|cell rsep|0fn>|<cwith|1|-1|1|-1|cell
      bsep|0fn>|<cwith|1|-1|1|-1|cell tsep|0fn>|<cwith|1|-1|1|-1|cell
      vcorrect|n>|<table|<row|<cell|<space|1fn|0ln|1ln>>>>>>

      Claridad del cdigo vs. velocidad<value|toc-dots><pageref|toc-6>

      2.5<space|2spc><format|no first indentation><tformat|<tformat|<cwith|1|-1|1|-1|cell
      tborder|1ln>|<twith|table width|1par>|<cwith|1|-1|1|-1|cell
      vmode|exact>|<cwith|1|-1|1|-1|cell height|1ln>|<cwith|1|-1|1|-1|cell
      lsep|0fn>|<cwith|1|-1|1|-1|cell rsep|0fn>|<cwith|1|-1|1|-1|cell
      bsep|0fn>|<cwith|1|-1|1|-1|cell tsep|0fn>|<cwith|1|-1|1|-1|cell
      vcorrect|n>|<table|<row|<cell|<space|1fn|0ln|1ln>>>>>>

      Motor flexible, "libre de polticas"<value|toc-dots><pageref|toc-7>

      <vspace*|1fn><with|font series|<quote|bold>|math font
      series|<quote|bold>|3<space|2spc><format|no first
      indentation><tformat|<tformat|<cwith|1|-1|1|-1|cell
      tborder|1ln>|<twith|table width|1par>|<cwith|1|-1|1|-1|cell
      vmode|exact>|<cwith|1|-1|1|-1|cell height|1ln>|<cwith|1|-1|1|-1|cell
      lsep|0fn>|<cwith|1|-1|1|-1|cell rsep|0fn>|<cwith|1|-1|1|-1|cell
      bsep|0fn>|<cwith|1|-1|1|-1|cell tsep|0fn>|<cwith|1|-1|1|-1|cell
      vcorrect|n>|<table|<row|<cell|<space|1fn|0ln|1ln>>>>>>

      La funcionalidad del kernel de <with|font
      shape|<quote|small-caps>|Yacas>><value|toc-dots><pageref|toc-8><vspace|0.5fn>

      <vspace*|1fn><with|font series|<quote|bold>|math font
      series|<quote|bold>|4<space|2spc><format|no first
      indentation><tformat|<tformat|<cwith|1|-1|1|-1|cell
      tborder|1ln>|<twith|table width|1par>|<cwith|1|-1|1|-1|cell
      vmode|exact>|<cwith|1|-1|1|-1|cell height|1ln>|<cwith|1|-1|1|-1|cell
      lsep|0fn>|<cwith|1|-1|1|-1|cell rsep|0fn>|<cwith|1|-1|1|-1|cell
      bsep|0fn>|<cwith|1|-1|1|-1|cell tsep|0fn>|<cwith|1|-1|1|-1|cell
      vcorrect|n>|<table|<row|<cell|<space|1fn|0ln|1ln>>>>>>

      The <with|font series|<quote|bold>|<with|font family|<quote|tt>|Yacas>>
      scripting language><value|toc-dots><pageref|toc-9><vspace|0.5fn>

      <vspace*|1fn><with|font series|<quote|bold>|math font
      series|<quote|bold>|5<space|2spc><format|no first
      indentation><tformat|<tformat|<cwith|1|-1|1|-1|cell
      tborder|1ln>|<twith|table width|1par>|<cwith|1|-1|1|-1|cell
      vmode|exact>|<cwith|1|-1|1|-1|cell height|1ln>|<cwith|1|-1|1|-1|cell
      lsep|0fn>|<cwith|1|-1|1|-1|cell rsep|0fn>|<cwith|1|-1|1|-1|cell
      bsep|0fn>|<cwith|1|-1|1|-1|cell tsep|0fn>|<cwith|1|-1|1|-1|cell
      vcorrect|n>|<table|<row|<cell|<space|1fn|0ln|1ln>>>>>>

      Currently supported CAS features><value|toc-dots><pageref|toc-10><vspace|0.5fn>

      <vspace*|1fn><with|font series|<quote|bold>|math font
      series|<quote|bold>|6<space|2spc><format|no first
      indentation><tformat|<tformat|<cwith|1|-1|1|-1|cell
      tborder|1ln>|<twith|table width|1par>|<cwith|1|-1|1|-1|cell
      vmode|exact>|<cwith|1|-1|1|-1|cell height|1ln>|<cwith|1|-1|1|-1|cell
      lsep|0fn>|<cwith|1|-1|1|-1|cell rsep|0fn>|<cwith|1|-1|1|-1|cell
      bsep|0fn>|<cwith|1|-1|1|-1|cell tsep|0fn>|<cwith|1|-1|1|-1|cell
      vcorrect|n>|<table|<row|<cell|<space|1fn|0ln|1ln>>>>>>

      Interface><value|toc-dots><pageref|toc-11><vspace|0.5fn>

      <vspace*|1fn><with|font series|<quote|bold>|math font
      series|<quote|bold>|7<space|2spc><format|no first
      indentation><tformat|<tformat|<cwith|1|-1|1|-1|cell
      tborder|1ln>|<twith|table width|1par>|<cwith|1|-1|1|-1|cell
      vmode|exact>|<cwith|1|-1|1|-1|cell height|1ln>|<cwith|1|-1|1|-1|cell
      lsep|0fn>|<cwith|1|-1|1|-1|cell rsep|0fn>|<cwith|1|-1|1|-1|cell
      bsep|0fn>|<cwith|1|-1|1|-1|cell tsep|0fn>|<cwith|1|-1|1|-1|cell
      vcorrect|n>|<table|<row|<cell|<space|1fn|0ln|1ln>>>>>>

      Documentation><value|toc-dots><pageref|toc-12><vspace|0.5fn>

      <vspace*|1fn><with|font series|<quote|bold>|math font
      series|<quote|bold>|8<space|2spc><format|no first
      indentation><tformat|<tformat|<cwith|1|-1|1|-1|cell
      tborder|1ln>|<twith|table width|1par>|<cwith|1|-1|1|-1|cell
      vmode|exact>|<cwith|1|-1|1|-1|cell height|1ln>|<cwith|1|-1|1|-1|cell
      lsep|0fn>|<cwith|1|-1|1|-1|cell rsep|0fn>|<cwith|1|-1|1|-1|cell
      bsep|0fn>|<cwith|1|-1|1|-1|cell tsep|0fn>|<cwith|1|-1|1|-1|cell
      vcorrect|n>|<table|<row|<cell|<space|1fn|0ln|1ln>>>>>>

      Future plans><value|toc-dots><pageref|toc-13><vspace|0.5fn>

      <vspace*|1fn><with|font series|<quote|bold>|math font
      series|<quote|bold>|9<space|2spc><format|no first
      indentation><tformat|<tformat|<cwith|1|-1|1|-1|cell
      tborder|1ln>|<twith|table width|1par>|<cwith|1|-1|1|-1|cell
      vmode|exact>|<cwith|1|-1|1|-1|cell height|1ln>|<cwith|1|-1|1|-1|cell
      lsep|0fn>|<cwith|1|-1|1|-1|cell rsep|0fn>|<cwith|1|-1|1|-1|cell
      bsep|0fn>|<cwith|1|-1|1|-1|cell tsep|0fn>|<cwith|1|-1|1|-1|cell
      vcorrect|n>|<table|<row|<cell|<space|1fn|0ln|1ln>>>>>>

      References><value|toc-dots><pageref|toc-14><vspace|0.5fn>
    </associate>
  </collection>
</auxiliary>
