<TeXmacs|1.0.1.14>

<style|generic>

<\body>
  <label|c1>

  <chapter|Getting started with <name|Yacas>>

  \;

  <label|c1s1>

  <\section>
    <value|hrule>

    Introduction
  </section>

  <with|font series|bold|<with|font family|tt|Yacas>> (Yet Another Computer
  Algebra System) is a small and highly flexible general-purpose computer
  algebra system and programming language. The language has a familiar,
  C-like infix-operator syntax. The distribution contains a small library of
  mathematical functions, but its real strength is in the language in which
  you can easily write your own symbolic manipulation algorithms. The core
  engine supports arbitrary precision arithmetic (for faster calculations, it
  can also optionally be linked with the GNU arbitrary precision math library
  <with|font series|bold|<with|font family|tt|libgmp>>) and is able to
  execute symbolic manipulations on various mathematical objects by following
  user-defined rules.

  Currently, the <with|font series|bold|<with|font family|tt|Yacas>>
  programming language is stable and seems powerful enough for all computer
  algebra applications. External libraries providing additional functionality
  may be dynamically loaded into <with|font series|bold|<with|font
  family|tt|Yacas>> via the "plugin" mechanism.

  <label|c1s2>

  <\section>
    <value|hrule>

    Installing <name|Yacas>
  </section>

  Read the file <with|font series|bold|<with|font family|tt|INSTALL>> for
  instructions on how to compile <with|font series|bold|<with|font
  family|tt|Yacas>>. <with|font series|bold|<with|font family|tt|Yacas>> is
  portable across most Unix-ish platforms and requires only a standard C++
  compiler such as <with|font series|bold|<with|font family|tt|g++>>.

  The base <with|font series|bold|<with|font family|tt|Yacas>> application
  accepts text as input and returns text as output. This makes it rather
  platform-independent. Apart from Unix-like systems, <with|font
  series|bold|<with|font family|tt|Yacas>> has been compiled on Windows and
  on EPOC32, aka Psion (which doesn't come with a standard C++ library!). The
  source code to compile <with|font series|bold|<with|font family|tt|Yacas>>
  for Windows can be found at the <hlink|Sourceforge
  repository|http://sourceforge.net/projects/yacas/> .

  For Unix, compilation basically amounts to the standard sequence

  <\code>
    ./configure

    make

    make install
  </code>

  This will install the binaries to <with|font series|bold|<with|font
  family|tt|/usr/local/bin>> and the library files to <with|font
  series|bold|<with|font family|tt|/usr/local/share/yacas/>>.

  The arbitrary precision math in <with|font series|bold|<with|font
  family|tt|Yacas>> will be generally faster if you compile <with|font
  series|bold|<with|font family|tt|Yacas>> with the <with|font
  series|bold|<with|font family|tt|libgmp>> library (the option <with|font
  series|bold|<with|font family|tt|--enable-gmp>> for the <with|font
  series|bold|<with|font family|tt|configure>> script). Precompiled Red Hat
  (RPM) and Debian (DEB) packages are also available.

  Additionally, <LaTeX>-formatted documentation in PostScript and PDF formats
  can be produced by the command

  <\code>
    make texdocs
  </code>

  <label|c1s3>

  <\section>
    <value|hrule>

    Using the console and <TeXmacs> modes
  </section>

  You can run <with|font series|bold|<with|font family|tt|Yacas>> in the
  console mode simply by typing <with|font series|bold|<with|font
  family|tt|yacas>>. The <with|font series|bold|<with|font family|tt|Yacas>>
  command prompt looks like this:

  <\code>
    In\<gtr\>
  </code>

  and, in command line interface, <with|font series|bold|<with|font
  family|tt|Yacas>>'s answers appear after the prompt

  <\code>
    Out\<gtr\>
  </code>

  In the <TeXmacs> interface you will see the start of a <name|Yacas> session
  in this way:

  <\session|yacas|default>
    <\input|yacas] >
      \;
    </input>
  </session>

  and if you put the cursor after the <verbatim|yacas]> indicator you will
  see that you are inside the session because text typed is true type font in
  blue like <with|color|blue|<verbatim|this>> and the box indicator of
  <TeXmacs> environment will appear. The outputs in the <TeXmacs> interface
  have not especial <verbatim|Out\<gtr\>> symbol but they are showed after
  each input in a pretty nice way, as we will see throught this document.

  A <with|font series|bold|<with|font family|tt|Yacas>> session may be
  terminated in the command shell interface by typing <with|font
  series|bold|<with|font family|tt|Exit()>> or <with|font
  series|bold|<with|font family|tt|quit>>. Pressing <with|font
  series|bold|<with|font family|tt|^C>> will also quit <with|font
  series|bold|<with|font family|tt|Yacas>>; however, pressing <with|font
  series|bold|<with|font family|tt|^C>> while <with|font
  series|bold|<with|font family|tt|Yacas>> is busy with a calculation will
  stop just that calculation. A session can be restarted (forgetting all
  previous definitions and results) by typing

  <\code>
    restart
  </code>

  In the <TeXmacs> interface you can just put your cursor outside of the
  session box to continue your writing or press the button stop wich appears
  in the contextual menu of the <name|Yacas> CAS session if you're inside a
  session box.

  Typically, you would enter one statement per line, for example

  <\session|yacas|default>
    \;

    <\input|yacas] >
      Sin(Pi/3);
    </input>

    <\output>
      <\with|mode|math>
        1
      </with>
    </output>

    \;
  </session>

  Statements should end with a semicolon (<with|font series|bold|<with|font
  family|tt|;>>) although this is not required (<with|font
  series|bold|<with|font family|tt|Yacas>> will append a semicolon at end of
  line to finish the statement).

  All documentation is accessible from the <with|font series|bold|<with|font
  family|tt|Yacas>> prompt. If you type

  <\code>
    In\<gtr\> ??
  </code>

  you should be able to read all available manuals; <with|font
  series|bold|<with|font family|tt|Yacas>> will run <with|font
  series|bold|<with|font family|tt|lynx>> or another browser to show you the
  HTML documentation. You can also get help on individual functions: to read
  about the function <with|font series|bold|<with|font family|tt|Sum()>>,
  type

  <\code>
    In\<gtr\> ?Sum
  </code>

  We are working trying to get some nice hipertextual help output inside the
  <TeXmacs> mode in a similar fashion that when you invoke a info or man page
  inside Konqueror or Nautilus file/web browsers.

  Type <with|font series|bold|<with|font family|tt|Example();>> to get some
  random examples of <with|font series|bold|<with|font family|tt|Yacas>>
  calculations.

  The command line has a history list, so it should be easy to browse through
  the expressions you entered previously using the Up and Down arrow keys.
  Typing the first few characters of a previous expression and then hitting
  the TAB key makes <with|font series|bold|<with|font family|tt|Yacas>>
  recall the last expression in the history list that matches these first
  characters.

  In <TeXmacs> mode the history of your commands in the <TeXmacs> document
  itself.

  Commands spanning multiple lines can (and actually have to) be entered by
  using a trailing backslash \\ at end of each continued line in the command
  prompt interface. For example:

  <\session|yacas|default>
    <\input|yacas] >
      a:=2+3+
    </input>

    <\output>
      CommandLine(1) : Error parsing expression
    </output>

    <\input|yacas] >
      \;
    </input>
  </session>

  \;

  <\code>
    In\<gtr\> a:=2+3+ \n In\<gtr\> 1

    Out\<gtr\> 6;
  </code>

  The error after our first attempt occurred because <with|font
  series|bold|<with|font family|tt|Yacas>> has appended a semicolon at end of
  the first line and <with|font series|bold|<with|font family|tt|2+3+;>> is
  not a valid <with|font series|bold|<with|font family|tt|Yacas>> expression.

  Incidentally, any text <with|font series|bold|<with|font family|tt|Yacas>>
  prints without a prompt is either messages printed by functions as their
  side-effect, or error messages. Resulting values of expressions are always
  printed after an <with|font series|bold|<with|font family|tt|Out\<gtr\>>>
  prompt.

  In the <TeXmacs> mode you cant, at this moment, enter multiline statements
  in <name|Yacas> sessions

  <label|c1s4>

  <\section>
    <value|hrule>

    <name|Yacas> as a symbolic calculator
  </section>

  We are ready to try some calculations. <with|font series|bold|<with|font
  family|tt|Yacas>> uses a C-like infix syntax and is case-sensitive. Here
  are some exact manipulations with fractions for a start:

  <\session|yacas|default>
    <\input|yacas] >
      1/14+5/21*(30-(1+1/2)*5^2);
    </input>

    <\output>
      <\with|mode|math>
        <frac|-12|7>
      </with>
    </output>

    \;
  </session>

  The standard scripts already contain a simple math library for symbolic
  simplification of basic algebraic functions. Any names such as <with|font
  series|bold|<with|font family|tt|x>> are treated as independent, symbolic
  variables and are not evaluated by default.

  <\session|yacas|default>
    <\input|yacas] >
      0+x;
    </input>

    <\output>
      <\with|mode|math>
        x
      </with>
    </output>

    <\input|yacas] >
      x+1*y;
    </input>

    <\output>
      <\with|mode|math>
        x+y
      </with>
    </output>

    <\input|yacas] >
      Sin(ArcSin(alpha))+ArcCos(Cos(beta));
    </input>

    <\output>
      <\with|mode|math>
        \<alpha\>+\<beta\>
      </with>
    </output>

    <\input|yacas] >
      (x+y)^3-(x-y)^3
    </input>

    <\output>
      <\with|mode|math>
        <left|(>x+y<right|)><rsup|3>-<left|(>x-y<right|)><rsup|3>
      </with>
    </output>

    <\input|yacas] >
      Simplify(%)
    </input>

    <\output>
      <\with|mode|math>
        6x<rsup|2>y+2y<rsup|3>
      </with>
    </output>

    \;
  </session>

  The special operator <with|font series|bold|<with|font family|tt|%>>
  automatically recalls the result from the previous line. The function
  <verbatim|Simplify> attempts to reduce an expression to a simpler form.
  Note that standard function names in <with|font series|bold|<with|font
  family|tt|Yacas>> are typically capitalized. Multiple capitalization such
  as <with|font series|bold|<with|font family|tt|ArcSin>> is sometimes used.
  The underscore character <with|font series|bold|<with|font family|tt|_>> is
  a reserved operator symbol and cannot be part of variable or function
  names.

  <with|font series|bold|<with|font family|tt|Yacas>> can deal with arbitrary
  precision numbers:

  <\session|yacas|default>
    <\input|yacas] >
      20!;
    </input>

    <\output>
      <\with|mode|math>
        2432902008176640000
      </with>
    </output>

    \;
  </session>

  When dealing with floating point numbers, the command <with|font
  series|bold|<with|font family|tt|Precision(n);>> can be used to specify
  that all floating point numbers should have a fixed precision of <with|font
  series|bold|<with|font family|tt|n>> digits:

  <\session|yacas|default>
    <\input|yacas] >
      Precision(30);
    </input>

    <\output>
      <\with|mode|math>
        <with|math font family|rm|True >
      </with>
    </output>

    <\input|yacas] >
      N(1/243);
    </input>

    <\output>
      <\with|mode|math>
        0.004115226337448559670781893004
      </with>
    </output>

    \;
  </session>

  Note that we need to enter <with|font series|bold|<with|font
  family|tt|N()>> to force the approximate calculation, otherwise the
  fraction would have been left unevaluated. The value <with|font
  series|bold|<with|font family|tt|True>> is a boolean constant.

  Analytic derivatives of functions can be evaluated:

  <\session|yacas|default>
    <\input|yacas] >
      D(x) Sin(x);
    </input>

    <\output>
      <\with|mode|math>
        cos x
      </with>
    </output>

    <\input|yacas] >
      D(x) D(x) Sin(x);
    </input>

    <\output>
      <\with|mode|math>
        -sin x
      </with>
    </output>

    \;
  </session>

  Rational numbers will stay rational as long as the numerator and
  denominator are integers, so <with|font series|bold|<with|font
  family|tt|55/10>> will evaluate to <with|font series|bold|<with|font
  family|tt|11/2>>. You can override this behaviour by using the numerical
  evaluation function <with|font series|bold|<with|font family|tt|N()>>. For
  example, <with|font series|bold|<with|font family|tt|N(55/10)>> will
  evaluate to <with|font series|bold|<with|font family|tt|5.5>> . This
  behaviour holds for most math functions. <with|font series|bold|<with|font
  family|tt|Yacas>> will try to maintain an exact answer (in terms of
  integers or fractions) instead of using floating point numbers, unless
  <with|font series|bold|<with|font family|tt|N()>> is used. Where the value
  for the constant <with|mode|math|\<pi\>> is needed, use the built-in
  variable <with|font series|bold|<with|font family|tt|Pi>>. It will be
  replaced by the (approximate) numerical value when <with|font
  series|bold|<with|font family|tt|N(Pi)>> is called. <with|font
  series|bold|<with|font family|tt|Yacas>> knows some simplification rules
  using <with|font series|bold|<with|font family|tt|Pi>> (especially with
  trigonometric functions). The imaginary unit <with|mode|math|\<mathi\>> is
  denoted <with|font series|bold|<with|font family|tt|I>> and complex numbers
  can be entered as either expressions involving <with|font
  series|bold|<with|font family|tt|I>> or explicitly <with|font
  series|bold|<with|font family|tt|Complex(a,b)>> for
  <with|mode|math|a+\<mathi\>**b>.

  Some simple equation solving algorithms are in place:

  <\session|yacas|default>
    <\input|yacas] >
      Solve(a+x*y==z,x);
    </input>

    <\output>
      <\with|mode|math>
        <frac|z-a|y>
      </with>
    </output>

    <\input|yacas] >
      Solve({11*x+3*y==1,2*x+y==0},{x,y})
    </input>

    <\output>
      <\with|mode|math>
        <left|(><expand|tabular*|<tformat|<cwith|1|-1|1|1|cell
        halign|c>|<cwith|1|-1|2|2|cell halign|c>|<table|<row|<cell|<frac|1|5>>|<cell|<frac|-2|5>>>>>><right|)>
      </with>
    </output>

    \;
  </session>

  (Note the use of the <with|font series|bold|<with|font family|tt|==>>
  operator, which does not evaluate to anything, to denote an "equation"
  object.) Currently <with|font series|bold|<with|font family|tt|Solve>> is
  rather limited and only deals with equations where the variable to be
  solved for only occurs once in the equation. In the future there will be
  more sophisticated algorithms.

  Taylor series are supported, for example:

  <\session|yacas|default>
    <\input|yacas] >
      Taylor(x,0,3) Exp(x)
    </input>

    <\output>
      <\with|mode|math>
        x+<frac|x<rsup|2>|2>+<frac|x<rsup|3>|6>+1
      </with>
    </output>

    \;
  </session>

  As this form of the answer may be a little bit hard to read, if you're in
  the command shell interface, you might then type

  <\code>
    In\<gtr\> PrettyForm(%);

    \ \ \ \ \ \ \ \ / 1 \\ \ \ \ 2 \ \ / 1 \\ \ \ \ 3

    1 + x + \| - \| * x \ + \| - \| * x

    \ \ \ \ \ \ \ \ \\ 2 / \ \ \ \ \ \ \ \\ 6 /

    \;

    Out\<gtr\> True;
  </code>

  The function <with|font series|bold|<with|font family|tt|PrettyForm()>>
  tries to render the formula in a better format for reading, using ASCII
  text. You can also export an expression to <TeX> by typing <with|font
  series|bold|<with|font family|tt|TeXForm(...)>>.

  <inactive|<label|c1s5>>

  <\section>
    <value|hrule>

    Variables
  </section>

  <with|font series|bold|<with|font family|tt|Yacas>> supports variables:

  <\session|yacas|default>
    <\input|yacas] >
      Set(a,Cos(0));
    </input>

    <\output>
      <\with|mode|math>
        <with|math font family|rm|True >
      </with>
    </output>

    <\input|yacas] >
      a:=a+1;
    </input>

    <\output>
      <\with|mode|math>
        2
      </with>
    </output>

    \;
  </session>

  The variable <with|font series|bold|<with|font family|tt|a>> has now been
  globally set to 2. The function <with|font series|bold|<with|font
  family|tt|Set()>> and the operator <with|font series|bold|<with|font
  family|tt|:=>> can both be used to assign values to global variables.
  (Variables local to procedures can also be defined; see below the chapters
  on programming.) To clear a variable binding, execute <with|font
  series|bold|<with|font family|tt|Clear(a);>> "<with|font
  series|bold|<with|font family|tt|a>>" will now evaluate to just <with|font
  series|bold|<with|font family|tt|a>>. This is one of the properties of the
  evaluation scheme of <with|font series|bold|<with|font family|tt|Yacas>>:
  when some object can not be evaluated or transformed any further, it is
  returned as the final result.

  Currently there is no difference between assigning variables using
  <with|font series|bold|<with|font family|tt|Set()>> or using the operator
  <with|font series|bold|<with|font family|tt|:=>>. The latter can however
  also assign lists and define functions.

  <inactive|<label|c1s6>>

  <\section>
    <value|hrule>

    Functions
  </section>

  The <with|font series|bold|<with|font family|tt|:=>> operator can be used
  to define functions:

  <\code>
    f(x):=2*x*x
  </code>

  will define a new function, <with|font series|bold|<with|font
  family|tt|f>>, that accepts one argument and returns twice the square of
  that argument.

  One and the same function name such as <with|font series|bold|<with|font
  family|tt|f>> may be used by different functions if they take different
  numbers of arguments (but not if they merely take different <with|font
  shape|italic|types> of arguments, since <with|font series|bold|<with|font
  family|tt|Yacas>> does not have a strict type system):

  <\session|yacas|default>
    <\input|yacas] >
      f(x):=x^2;
    </input>

    <\output>
      <\with|mode|math>
        <with|math font family|rm|True >
      </with>
    </output>

    <\input|yacas] >
      f(x,y):=x*y;
    </input>

    <\output>
      <\with|mode|math>
        <with|math font family|rm|True >
      </with>
    </output>

    <\input|yacas] >
      f(3)+f(3,2);
    </input>

    <\output>
      <\with|mode|math>
        15
      </with>
    </output>

    \;
  </session>

  Functions may return values of any type, or may even return values of
  different types at different times.

  <with|font series|bold|<with|font family|tt|Yacas>> predefines <with|font
  series|bold|<with|font family|tt|True>> and <with|font
  series|bold|<with|font family|tt|False>> as boolean values. Functions
  returning boolean values are called <with|font shape|italic|predicates>.
  For example, <with|font series|bold|<with|font family|tt|IsNumber()>> and
  <with|font series|bold|<with|font family|tt|IsInteger()>> are predicates
  defined in the standard library:

  <\session|yacas|default>
    <\input|yacas] >
      IsNumber(2+x);
    </input>

    <\output>
      <\with|mode|math>
        <with|math font family|rm|False >
      </with>
    </output>

    <\input|yacas] >
      IsInteger(15/5);
    </input>

    <\output>
      <\with|mode|math>
        <with|math font family|rm|True >
      </with>
    </output>

    \;
  </session>

  When assigning variables, the right hand side is evaluated before it is
  assigned. Thus

  <\code>
    a:=2*2
  </code>

  will set <with|font series|bold|<with|font family|tt|a>> to 4. This is
  however <with|font shape|italic|not> the case for functions. When entering
  <with|font series|bold|<with|font family|tt|f(x):=x+x>> the right hand
  side, <with|font series|bold|<with|font family|tt|x+x>>, is not evaluated
  before being assigned. This can be forced by using <with|font
  series|bold|<with|font family|tt|Eval()>>:

  <\code>
    f(x):=Eval(x+x)
  </code>

  will first evaluate <with|font series|bold|<with|font family|tt|x+x>> to
  <with|font series|bold|<with|font family|tt|2*x>> before assigning it to
  the user function f. This specific example is not a very useful one but it
  will come in handy when the operation being performed on the right hand
  side is expensive. For example, if we evaluate a Taylor series expansion
  before assigning it to the user-defined function, the engine doesn't need
  to create the Taylor series expansion each time that user-defined function
  is called.

  <inactive|<label|c1s7>>

  <\section>
    <value|hrule>

    Strings and lists
  </section>

  In addition to numbers and variables, <with|font series|bold|<with|font
  family|tt|Yacas>> supports strings and lists. Strings are simply sequences
  of characters enclosed by double quotes, for example:

  <\code>
    "this is a string with \\"quotes\\" in it"
  </code>

  Lists are ordered groups of items, as usual. <with|font
  series|bold|<with|font family|tt|Yacas>> represents lists by putting the
  objects between braces and separating them with commas. The list consisting
  of objects <with|font series|bold|<with|font family|tt|a>>, <with|font
  series|bold|<with|font family|tt|b>>, and <with|font series|bold|<with|font
  family|tt|c>> could be entered by typing <with|font series|bold|<with|font
  family|tt|{a,b,c}>>. In <with|font series|bold|<with|font
  family|tt|Yacas>>, vectors are represented as lists and matrices as lists
  of lists. In fact, any <with|font series|bold|<with|font family|tt|Yacas>>
  expression can be converted to a list (see below).

  Items in a list can be accessed through the <with|font
  series|bold|<with|font family|tt|[ ]>> operator. Examples: when you enter

  <\code>
    uu:={a,b,c,d,e,f};
  </code>

  then

  <\code>
    uu[2];
  </code>

  evaluates to b, and

  <\code>
    uu[2 .. 4];
  </code>

  evaluates to <with|font series|bold|<with|font family|tt|{b,c,d}>>. The
  "range" expression

  <\code>
    2 .. 4
  </code>

  evaluates to <with|font series|bold|<with|font family|tt|{2,3,4}>>. Note
  that spaces around the <with|font series|bold|<with|font family|tt|..>>
  operator are necessary, or else the parser will not be able to distinguish
  it from a part of a number.

  Another use of lists is the associative list, sometimes called a hash
  table, which is implemented in <with|font series|bold|<with|font
  family|tt|Yacas>> simply as a list of key-value pairs. Keys must be strings
  and values may be any objects. Associative lists can also work as
  mini-databases. As an example, first enter

  <\session|yacas|default>
    <\input|yacas] >
      u:={};
    </input>

    <\output>
      CommandLine(1) : Invalid argument
    </output>

    \;
  </session>

  and then

  <\session|yacas|default>
    <\input|yacas] >
      u["name"] := "Isaia"
    </input>

    <\output>
      <\with|mode|math>
        <with|math font family|rm|True >
      </with>
    </output>

    <\input|yacas] >
      u["occupation"] := "prophet";
    </input>

    <\output>
      <\with|mode|math>
        <with|math font family|rm|True >
      </with>
    </output>

    <\input|yacas] >
      u["is alive"]:=False;
    </input>

    <\output>
      <\with|mode|math>
        <with|math font family|rm|True >
      </with>
    </output>

    \;
  </session>

  Now, <with|font series|bold|<with|font family|tt|u["name"]>> would return
  <with|font series|bold|<with|font family|tt|"Isaia">>. The list <with|font
  series|bold|<with|font family|tt|u>> now contains three sublists, as we can
  see:

  <\session|yacas|default>
    <\input|yacas] >
      u;
    </input>

    <\output>
      <\with|mode|math>
        <left|(><expand|tabular*|<tformat|<cwith|1|-1|1|1|cell
        halign|c>|<cwith|1|-1|2|2|cell halign|c>|<table|<row|<cell|<with|math
        font family|rm|is alive>>|<cell|<with|math font family|rm|False
        >>>|<row|<cell|<with|math font family|rm|occupation>>|<cell|<with|math
        font family|rm|prophet>>>|<row|<cell|<with|math font
        family|rm|name>>|<cell|<with|math font family|rm|Isaia>>>>>><right|)>
      </with>
    </output>

    \;
  </session>

  Lists evaluate their arguments, and return a list with results of
  evaluating each element. So, typing <with|font series|bold|<with|font
  family|tt|{1+2,3};>> would evaluate to <with|font series|bold|<with|font
  family|tt|{3,3}>>.

  Assignment of multiple variables is also possible using lists. For
  instance, <with|font series|bold|<with|font family|tt|{x,y}:={2!,3!}>> will
  result in 2 being assigned to <with|font series|bold|<with|font
  family|tt|x>> and 6 to <with|font series|bold|<with|font family|tt|y>>.

  The idea of using lists to represent expressions dates back to the language
  LISP developed in the 1970's. From a small set of operations on lists, very
  powerful symbolic manipulation algorithms can be built. Lists can also be
  used as function arguments when a variable number of arguments are
  expected.

  Let's try some list operations now:

  <\session|yacas|default>
    <\input|yacas] >
      Clear(a); // first clean the variable a from previous assingments in
      this document
    </input>

    <\output>
      <\with|mode|math>
        <with|math font family|rm|True >
      </with>
    </output>

    <\input|yacas] >
      m := {a,b,c};
    </input>

    <\output>
      <\with|mode|math>
        <left|(>a,b,c<right|)>
      </with>
    </output>

    <\input|yacas] >
      Length(m);
    </input>

    <\output>
      <\with|mode|math>
        3
      </with>
    </output>

    <\input|yacas] >
      Reverse(m);
    </input>

    <\output>
      <\with|mode|math>
        <with|math font family|rm|Reverse
        ><left|(><expand|tabular*|<tformat|<cwith|1|-1|1|1|cell
        halign|c>|<cwith|1|-1|2|2|cell halign|c>|<cwith|1|-1|3|3|cell
        halign|c>|<table|<row|<cell|a>|<cell|b>|<cell|c>>>>><right|)>
      </with>
    </output>

    <\input|yacas] >
      Concat(m,m);
    </input>

    <\output>
      <\with|mode|math>
        <left|(>a,b,c,a,b,c<right|)>
      </with>
    </output>

    <\input|yacas] >
      m[1] := "blah blah";
    </input>

    <\output>
      <\with|mode|math>
        <with|math font family|rm|True >
      </with>
    </output>

    <\input|yacas] >
      m;
    </input>

    <\output>
      <\with|mode|math>
        <left|(><with|math font family|rm|blah blah>,b,c<right|)>
      </with>
    </output>

    <\input|yacas] >
      Nth(m,2);
    </input>

    <\output>
      <\with|mode|math>
        b
      </with>
    </output>

    \;
  </session>

  Many more list operations are described in the reference manual.

  <inactive|<label|c1s8>>

  <\section>
    <value|hrule>

    Linear Algebra
  </section>

  Vectors of fixed dimension are represented as lists of their components.
  The list <with|font series|bold|<with|font family|tt|{1,2,3}>> would be a
  three-dimensional vector with components 1, 2 and 3. Matrices are
  represented as a vector of vectors.

  Vector components can be assigned values just like list items, since they
  are in fact list items:

  <\session|yacas|default>
    <\input|yacas] >
      l:=ZeroVector(3);
    </input>

    <\output>
      <\with|mode|math>
        <left|(>0,0,0<right|)>
      </with>
    </output>

    <\input|yacas] >
      l[ 2 ]:=2;
    </input>

    <\output>
      <\with|mode|math>
        <with|math font family|rm|True >
      </with>
    </output>

    <\input|yacas] >
      l;
    </input>

    <\output>
      <\with|mode|math>
        <left|(>0,2,0<right|)>
      </with>
    </output>

    \;
  </session>

  <with|font series|bold|<with|font family|tt|Yacas>> can perform
  multiplication of matrices, vectors and numbers as usual in linear algebra:

  <\session|yacas|default>
    <\input|yacas] >
      v:={1,0,0,0}
    </input>

    <\output>
      <\with|mode|math>
        <left|(>1,0,0,0<right|)>
      </with>
    </output>

    <\input|yacas] >
      E4:={ {0,u1,0,0},{d0,0,u2,0},{0,d1,0,0},{0,0,d2,0}}
    </input>

    <\output>
      <\with|mode|math>
        <left|(><expand|tabular*|<tformat|<cwith|1|-1|1|1|cell
        halign|c>|<cwith|1|-1|2|2|cell halign|c>|<cwith|1|-1|3|3|cell
        halign|c>|<cwith|1|-1|4|4|cell halign|c>|<table|<row|<cell|0>|<cell|u<rsub|1>>|<cell|0>|<cell|0>>|<row|<cell|d<rsub|0>>|<cell|0>|<cell|u<rsub|2>>|<cell|0>>|<row|<cell|0>|<cell|d<rsub|1>>|<cell|0>|<cell|0>>|<row|<cell|0>|<cell|0>|<cell|d<rsub|2>>|<cell|0>>>>><right|)>
      </with>
    </output>

    <\input|yacas] >
      CharacteristicEquation(E4,x)
    </input>

    <\output>
      <\with|mode|math>
        x<rsup|4>-x*u<rsub|2>d<rsub|1>x-u<rsub|1>d<rsub|0>x<rsup|2>
      </with>
    </output>

    <\input|yacas] >
      Expand(%,x)
    </input>

    <\output>
      <\with|mode|math>
        x<rsup|4>-<left|(>u<rsub|2>d<rsub|1>+u<rsub|1>d<rsub|0><right|)>x<rsup|2>
      </with>
    </output>

    <\input|yacas] >
      v+E4*v+E4*E4*v+E4*E4*E4*v
    </input>

    <\output>
      <\with|mode|math>
        <left|(>u<rsub|1>d<rsub|0>+1,d<rsub|0>+<left|(>d<rsub|0>u<rsub|1>+u<rsub|2>d<rsub|1><right|)>d<rsub|0>,d<rsub|1>d<rsub|0>,d<rsub|2>d<rsub|1>d<rsub|0><right|)>
      </with>
    </output>

    \;
  </session>

  The standard <with|font series|bold|<with|font family|tt|Yacas>> script
  library also includes taking the determinant and inverse of a matrix,
  finding eigenvectors and eigenvalues (in simple cases) and solving linear
  sets of equations, such as <with|mode|math|A*x=b> where <with|mode|math|A>
  is a matrix, and <with|mode|math|x> and <with|mode|math|b> are vectors.
  There are several more matrix operations supported. See the reference
  manual for more details.

  <inactive|<label|c1s9>>

  <\section>
    <value|hrule>

    Control flow: conditionals, loops, blocks
  </section>

  The <with|font series|bold|<with|font family|tt|Yacas>> language includes
  some constructs and functions for control flow. Looping can be done with
  either a <with|font series|bold|<with|font family|tt|ForEach()>> or a
  <with|font series|bold|<with|font family|tt|While()>> function call. The
  function <with|font series|bold|<with|font family|tt|ForEach(x, list)
  body>> executes its body for each element of the list and assigns the
  variable <with|font series|bold|<with|font family|tt|x>> to that element
  each time. The function call <with|font series|bold|<with|font
  family|tt|While(predicate) body>> repeats the "body" until the "predicate"
  returns <with|font series|bold|<with|font family|tt|False>>.

  Conditional execution is implemented by the <with|font
  series|bold|<with|font family|tt|If(predicate, body1, body2)>> function
  call, which works like the C language construct <with|font
  series|bold|<with|font family|tt|(predicate) ? body1 : body2>>. If the
  condition is true, "body1" is evaluated, otherwise "body2" is evaluated,
  and the corresponding value is returned. For example, the absolute value of
  a number can be computed with:

  <\code>
    absx := If( x\<gtr\>=0, x, -x );
  </code>

  (The library function <with|font series|bold|<with|font family|tt|Abs()>>
  does this already.)

  If several operations need to be executed in sequence to obtain a result,
  you can use a <with|font series|bold|<with|font family|tt|Prog()>> function
  call or equivalently the <with|font series|bold|<with|font family|tt|[ ]>>
  construct.

  To illustrate these features, let us create a list of all even integers
  from 2 to 20 and compute the product of all those integers except those
  divisible by 3. (What follows is not necessarily the most economical way to
  do it in <with|font series|bold|<with|font family|tt|Yacas>>.)

  <\session|yacas|default>
    <\input|yacas] >
      L := {};
    </input>

    <\output>
      CommandLine(1) : Invalid argument
    </output>

    <\input|yacas] >
      i := 2;
    </input>

    <\output>
      <\with|mode|math>
        2
      </with>
    </output>

    <\input|yacas] >
      While(i\<less\>=20) [ L:= Append(L, i); i := i+2; ]
    </input>

    <\output>
      <\with|mode|math>
        <with|math font family|rm|True >
      </with>
    </output>

    <\input|yacas] >
      L;
    </input>

    <\output>
      <\with|mode|math>
        <left|(>2,4,6,8,10,12,14,16,18,20<right|)>
      </with>
    </output>

    <\input|yacas] >
      answer := 1;
    </input>

    <\output>
      <\with|mode|math>
        1
      </with>
    </output>

    <\input|yacas] >
      ForEach(i, L) If (Mod(i, 3)!=0, answer := answer * i);
    </input>

    <\output>
      <\with|mode|math>
        <with|math font family|rm|True >
      </with>
    </output>

    <\input|yacas] >
      answer;
    </input>

    <\output>
      <\with|mode|math>
        2867200
      </with>
    </output>

    \;
  </session>

  We used a shorter form of <with|font series|bold|<with|font
  family|tt|If(predicate, body)>> with only one body which is executed when
  the condition holds. If the condition does not hold, this function call
  returns <with|font series|bold|<with|font family|tt|False>>.

  \;
</body>

<\initial>
  <\collection>
    <associate|paragraph width|150mm>
    <associate|odd page margin|30mm>
    <associate|page right margin|30mm>
    <associate|page top margin|30mm>
    <associate|reduction page right margin|25mm>
    <associate|reduction page bottom margin|15mm>
    <associate|even page margin|30mm>
    <associate|reduction page left margin|25mm>
    <associate|page bottom margin|30mm>
    <associate|reduction page top margin|15mm>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|toc-10|<tuple|<uninit>|?>>
    <associate|c1|<tuple|<uninit>|?>>
    <associate|toc-1|<tuple|<uninit>|?>>
    <associate|c1s1|<tuple|<uninit>|?>>
    <associate|c1s2|<tuple|<uninit>|?>>
    <associate|toc-2|<tuple|<uninit>|?>>
    <associate|c1s3|<tuple|<uninit>|?>>
    <associate|toc-3|<tuple|<uninit>|?>>
    <associate|toc-4|<tuple|<uninit>|?>>
    <associate|c1s4|<tuple|<uninit>|?>>
    <associate|toc-5|<tuple|<uninit>|?>>
    <associate|c1s5|<tuple|<uninit>|?>>
    <associate|toc-6|<tuple|<uninit>|?>>
    <associate|c1s6|<tuple|<uninit>|?>>
    <associate|toc-7|<tuple|<uninit>|?>>
    <associate|c1s7|<tuple|<uninit>|?>>
    <associate|c1s8|<tuple|<uninit>|?>>
    <associate|toc-8|<tuple|<uninit>|?>>
    <associate|c1s9|<tuple|<uninit>|?>>
    <associate|toc-9|<tuple|<uninit>|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <vspace*|1fn><with|font series|<quote|bold>|math font
      series|<quote|bold>|Getting started with <with|font
      shape|<quote|small-caps>|Yacas>><value|toc-dots><pageref|toc-1><vspace|0.5fn>

      <format|no first indentation><tformat|<tformat|<cwith|1|-1|1|-1|cell
      tborder|1ln>|<twith|table width|1par>|<cwith|1|-1|1|-1|cell
      vmode|exact>|<cwith|1|-1|1|-1|cell height|1ln>|<cwith|1|-1|1|-1|cell
      lsep|0fn>|<cwith|1|-1|1|-1|cell rsep|0fn>|<cwith|1|-1|1|-1|cell
      bsep|0fn>|<cwith|1|-1|1|-1|cell tsep|0fn>|<cwith|1|-1|1|-1|cell
      vcorrect|n>|<table|<row|<cell|<space|1fn|0ln|1ln>>>>>>

      Introduction<value|toc-dots><pageref|toc-2>

      <format|no first indentation><tformat|<tformat|<cwith|1|-1|1|-1|cell
      tborder|1ln>|<twith|table width|1par>|<cwith|1|-1|1|-1|cell
      vmode|exact>|<cwith|1|-1|1|-1|cell height|1ln>|<cwith|1|-1|1|-1|cell
      lsep|0fn>|<cwith|1|-1|1|-1|cell rsep|0fn>|<cwith|1|-1|1|-1|cell
      bsep|0fn>|<cwith|1|-1|1|-1|cell tsep|0fn>|<cwith|1|-1|1|-1|cell
      vcorrect|n>|<table|<row|<cell|<space|1fn|0ln|1ln>>>>>>

      Installing <with|font shape|<quote|small-caps>|Yacas><value|toc-dots><pageref|toc-3>

      <format|no first indentation><tformat|<tformat|<cwith|1|-1|1|-1|cell
      tborder|1ln>|<twith|table width|1par>|<cwith|1|-1|1|-1|cell
      vmode|exact>|<cwith|1|-1|1|-1|cell height|1ln>|<cwith|1|-1|1|-1|cell
      lsep|0fn>|<cwith|1|-1|1|-1|cell rsep|0fn>|<cwith|1|-1|1|-1|cell
      bsep|0fn>|<cwith|1|-1|1|-1|cell tsep|0fn>|<cwith|1|-1|1|-1|cell
      vcorrect|n>|<table|<row|<cell|<space|1fn|0ln|1ln>>>>>>

      Using the console and T<rsub|<space|-0.4spc><move|<resize|<with|index
      level|<quote|0>|E>||||0.5fn|>|0fn|-0.1fn>><space|-0.4spc>X<rsub|<space|-0.4spc><move|<resize|M<space|-0.2spc>A<space|-0.4spc>CS||||0.5fn|>|0fn|-0.1fn>>
      modes<value|toc-dots><pageref|toc-4>

      <format|no first indentation><tformat|<tformat|<cwith|1|-1|1|-1|cell
      tborder|1ln>|<twith|table width|1par>|<cwith|1|-1|1|-1|cell
      vmode|exact>|<cwith|1|-1|1|-1|cell height|1ln>|<cwith|1|-1|1|-1|cell
      lsep|0fn>|<cwith|1|-1|1|-1|cell rsep|0fn>|<cwith|1|-1|1|-1|cell
      bsep|0fn>|<cwith|1|-1|1|-1|cell tsep|0fn>|<cwith|1|-1|1|-1|cell
      vcorrect|n>|<table|<row|<cell|<space|1fn|0ln|1ln>>>>>>

      <with|font shape|<quote|small-caps>|Yacas> as a symbolic
      calculator<value|toc-dots><pageref|toc-5>

      <format|no first indentation><tformat|<tformat|<cwith|1|-1|1|-1|cell
      tborder|1ln>|<twith|table width|1par>|<cwith|1|-1|1|-1|cell
      vmode|exact>|<cwith|1|-1|1|-1|cell height|1ln>|<cwith|1|-1|1|-1|cell
      lsep|0fn>|<cwith|1|-1|1|-1|cell rsep|0fn>|<cwith|1|-1|1|-1|cell
      bsep|0fn>|<cwith|1|-1|1|-1|cell tsep|0fn>|<cwith|1|-1|1|-1|cell
      vcorrect|n>|<table|<row|<cell|<space|1fn|0ln|1ln>>>>>>

      Variables<value|toc-dots><pageref|toc-6>

      <format|no first indentation><tformat|<tformat|<cwith|1|-1|1|-1|cell
      tborder|1ln>|<twith|table width|1par>|<cwith|1|-1|1|-1|cell
      vmode|exact>|<cwith|1|-1|1|-1|cell height|1ln>|<cwith|1|-1|1|-1|cell
      lsep|0fn>|<cwith|1|-1|1|-1|cell rsep|0fn>|<cwith|1|-1|1|-1|cell
      bsep|0fn>|<cwith|1|-1|1|-1|cell tsep|0fn>|<cwith|1|-1|1|-1|cell
      vcorrect|n>|<table|<row|<cell|<space|1fn|0ln|1ln>>>>>>

      Functions<value|toc-dots><pageref|toc-7>

      <format|no first indentation><tformat|<tformat|<cwith|1|-1|1|-1|cell
      tborder|1ln>|<twith|table width|1par>|<cwith|1|-1|1|-1|cell
      vmode|exact>|<cwith|1|-1|1|-1|cell height|1ln>|<cwith|1|-1|1|-1|cell
      lsep|0fn>|<cwith|1|-1|1|-1|cell rsep|0fn>|<cwith|1|-1|1|-1|cell
      bsep|0fn>|<cwith|1|-1|1|-1|cell tsep|0fn>|<cwith|1|-1|1|-1|cell
      vcorrect|n>|<table|<row|<cell|<space|1fn|0ln|1ln>>>>>>

      Strings and lists<value|toc-dots><pageref|toc-8>

      <format|no first indentation><tformat|<tformat|<cwith|1|-1|1|-1|cell
      tborder|1ln>|<twith|table width|1par>|<cwith|1|-1|1|-1|cell
      vmode|exact>|<cwith|1|-1|1|-1|cell height|1ln>|<cwith|1|-1|1|-1|cell
      lsep|0fn>|<cwith|1|-1|1|-1|cell rsep|0fn>|<cwith|1|-1|1|-1|cell
      bsep|0fn>|<cwith|1|-1|1|-1|cell tsep|0fn>|<cwith|1|-1|1|-1|cell
      vcorrect|n>|<table|<row|<cell|<space|1fn|0ln|1ln>>>>>>

      Linear Algebra<value|toc-dots><pageref|toc-9>

      <format|no first indentation><tformat|<tformat|<cwith|1|-1|1|-1|cell
      tborder|1ln>|<twith|table width|1par>|<cwith|1|-1|1|-1|cell
      vmode|exact>|<cwith|1|-1|1|-1|cell height|1ln>|<cwith|1|-1|1|-1|cell
      lsep|0fn>|<cwith|1|-1|1|-1|cell rsep|0fn>|<cwith|1|-1|1|-1|cell
      bsep|0fn>|<cwith|1|-1|1|-1|cell tsep|0fn>|<cwith|1|-1|1|-1|cell
      vcorrect|n>|<table|<row|<cell|<space|1fn|0ln|1ln>>>>>>

      Control flow: conditionals, loops, blocks<value|toc-dots><pageref|toc-10>
    </associate>
  </collection>
</auxiliary>
