<TeXmacs|1.0.1.14>

<style|generic>

<\body>
  <label|c1><chapter|Iniciar con <name|Yacas>>

  <inactive|<label|c1s1>>

  <\section>
    <value|hrule>

    Introduccin
  </section>

  <name|Yacas> (por las siglas en ingls para Yet Another Computer Algebra
  System) es un pequeo y ltamente flexible sistema de lgebra computacional
  de propsito general y un lenguaje de programacin. El lenguaje tiene una
  familar sintaxis tipo C con operadores infijos. La distribucin contiene
  una pequea biblioteca de funciones matemticas, pero su real fortaleza
  estn en el lenguaje en el cual usted puede escribir sus propios algoritmos
  de manipulacin simblica. El motor ncleo soporta aritmtica de precisin
  arbitraria (para clculos ms rpidos, puede tambin opcionalmente ser
  enlazado con la biblioteca matemtica GNU de precisin arbitraria
  <verbatim|libgmp>) y es capaz de ejecutar manipulaciones simblicas en
  varios objetos matemticos siguiendo las reglas definidas por el usuario.

  Actualmente, el lenguaje de programacin <name|Yacas> es estable y parece
  suficientemente poderoso para todas las aplicaciones de lgebra
  computacional. La bibliotecas externas que proveen funcionalidad adicional
  pueden ser dinmicamente cargadas en <name|Yacas> va el mecanismo
  "conector".

  <inactive|<label|c1s2>>

  <\section>
    <value|hrule>

    Instalar <name|Yacas>
  </section>

  Lea el archivo <verbatim|INSTALL> para las instrucciones sobre cmo
  compilar <name|Yacas>. <name|Yacas> es portable a lo largo de varias
  plataformas tipo Unix y requiere slo un compilador estandar C++ tal como
  <verbatim|g++>.

  La base de la aplicacin <name|Yacas> acepta texto como entrada y retorna
  texto como salida. Esto lo hace bastante independiente respecto a la
  plataforma. Aparte de sistemas tipo Unix, <name|Yacas> ha sido compilado en
  Windows y sobre EPOC32, tambin conocido como Psion (que no viene con una
  biblioteca estndar de C++!). El cdigo fuente para compilar <name|Yacas>
  desde Windows puede ser encontrado en el \ <hlink|repositorio
  Sourceforge|http://sourceforge.net/projects/yacas/>.

  Para Unix, la compilacin bsicamente equivale a la secuencia estndar

  <\code>
    ./configure

    make

    make install
  </code>

  Esto instalar los binarios en <with|font series|bold|<with|font
  family|tt|/usr/local/bin>> y los archivos de biblioteca en <with|font
  series|bold|<with|font family|tt|/usr/local/share/yacas/>>.

  La matemtica de precisin arbitraria en <name|Yacas> ser generada ms
  rpido si usted compila <name|Yacas> con la biblioteca <verbatim|libgmp>
  (la opcin <verbatim|-enable-gmp> para el <em|script>
  <verbatim|configure>). Paquetes precompilados Red Hat (RPM) y Debian (DEB)
  estn tambin disponibles.

  Adicionalmente, documentacin formateada en <LaTeX> en formatos PostScript
  y PDF puede ser producida por el comando

  <\code>
    make texdocs
  </code>

  <inactive|<label|c1s3>>

  <\section>
    <value|hrule>

    Usando el modo de consola y el modo <TeXmacs>
  </section>

  Puede correr <name|Yacas> el el modo de consola simplemente tecleando
  <verbatim|yacas>. El <em|prompt> de comandos <name|Yacas> lucir como esto:

  <\code>
    In\<gtr\>
  </code>

  y, en la interface de lnea de comandos, las respuestas de <name|Yacas>
  aparecern despus del <em|prompt>

  <\code>
    Out\<gtr\>
  </code>

  En la interface <TeXmacs> ver el comienzo de una sesin <name|Yacas> de
  esta forma:

  <\session|yacas|default>
    <\input|yacas] >
      \;
    </input>
  </session>

  y si usted coloca el cursos despus del indicador <verbatim|yacas]> ver
  que est dentro de a sesin porque el texto que teclee tiene fuente true
  type azul como <with|color|blue|<verbatim|esta>> y la caja indicadora de
  entornos <TeXmacs> aparecer. Las salidas en la interface <TeXmacs> no
  tienen el smbolo especial <verbatim|Out\<gtr\>> pero son mostradas despus
  de cada entrada en una forma muy agradable, como ver a lo largo de este
  documento.

  Una sesin de <name|Yacas> puede ser terminada en la interface de consola
  de comandos teclando <with|font series|bold|<with|font family|tt|Exit()>> o
  <with|font series|bold|<with|font family|tt|quit>>. Presionando <with|font
  series|bold|<with|font family|tt|^C>> tambin saldr de <name|Yacas>; en
  embargo presionar <with|font series|bold|<with|font family|tt|^C>> mientras
  <name|Yacas> est ocupado con un clculo slo detendr ese clculo. Una
  sesin puede ser reiniciada (olvidando todas las definiciones previas y
  resultados) tecleando

  <\code>
    restart
  </code>

  En la interface <TeXmacs> puede slo colocar el cursor fuera de la caja de
  sesin para continuar su escrito o presionar el botn "stop" que aparece en
  el men contextual en la sesin CAS de <name|Yacas> si usted est dentro de
  una caja de sesin.

  Tpicamente, usted entara una sentencia por lnea, por ejemplo

  <\session|yacas|default>
    \;

    <\input|yacas] >
      Sin(Pi/2);
    </input>

    <\output>
      <\with|mode|math>
        1
      </with>
    </output>

    \;
  </session>

  Las sentencias deben terminar con un punto y coma (<verbatim|;>) aunque
  esto no es requerido (<name|Yacas> anexar un punto y coma al final de la
  lnea para finalizar la sentencia).

  Toda la documentacin es accesible desde el <em|prompt> de <name|Yacas>. Si
  teclea

  <\code>
    In\<gtr\> ??
  </code>

  Deber ser capaz de leer todos los manuales disponibles; <name|Yacas>
  ejecutar <with|font family|tt|lynx> u otro navegador para mostrarle la
  documentacin HTML. Tambin puede obtener ayuda sobre las funciones
  individuales: para leer sobre la funcin <with|font family|tt|Sum()>,
  teclee

  <\code>
    In\<gtr\> ?Sum
  </code>

  Estamos trabajando intentando obtener algunas salidas de ayuda hipertextual
  agradables en el modo <TeXmacs> en una forma similar a cuando usted invoca
  una pgina info o man dentro del los navegadores de archivos y Web
  Konqueror o Nautilus.

  Teclee <with|font family|tt|Example();> para obtener algunos ejemplos
  aleatorios de clculos <name|Yacas>.

  La lnea de comandos tiene una lista histrica, as que debe ser fcil
  navegar a travs de las expresiones que ha ingreado previamente usando las
  teclas de Arriba y Abajo. Teclear uno pocos caracters inicales de una
  expresin y presionando la tecla TAB hace que <name|Yacas> recuerde la
  ltima expresin en la historia que coincide con esos caracteres iniciales.

  El el modo <TeXmacs> la historia de sus comandos es el documento <TeXmacs>
  en s mismo.

  Los comandos que se extienden en mltiples lneas puede (y de hecho tienen
  que) ser ingresados usando un <em|backslash> de arrastre al final de cada
  lnea continuada en la interface de lnea de comandos. Por ejemplo:

  <\session|yacas|default>
    <\input|yacas] >
      a:=2+3+
    </input>

    <\output>
      CommandLine(1) : Error parsing expression
    </output>

    <\input|yacas] >
      \;
    </input>
  </session>

  \;

  <\code>
    In\<gtr\> a:=2+3+ \\\ 

    In\<gtr\> 1

    Out\<gtr\> 6;
  </code>

  El primer error despus de nuestro primer intento ocurri porque
  <name|Yacas> ha anexado un punto y coma al final de la primera lnea y
  <with|font family|tt|2+3+;> no es una expresin <name|Yacas> vlida.

  Incidentalmente, cualquier texto que <name|Yacas> imprime sin un
  <em|prompt> es o bien un mensaje impreso por las funciones como su efecto
  colateral, o un mesaje de error. Los valores resultantes de las expresiones
  son siempre impresos despus de un <em|prompt> <with|font
  series|bold|<with|font family|tt|Out\<gtr\>>>

  En el modo <TeXmacs> usted no puede, en este momento, ingresar sentencias
  multilnea en las sesiones de <name|Yacas>.

  <inactive|<label|c1s4>>

  <\section>
    <value|hrule>

    <name|Yacas> como una calculadora simblica
  </section>

  Estamos listos para tratar algunos clculos. <name|Yacas> usa una sintaxis
  infija tipo C y es sensible a las maysculas. Ac estn algunas
  manipulaciones exactas con fracciones para empezar:

  <\session|yacas|default>
    <\input|yacas] >
      1/14+5/21*(30-(1+1/2)*5^2);
    </input>

    <\output>
      <\with|mode|math>
        <frac|-12|7>
      </with>
    </output>

    \;
  </session>

  Los <em|scripts> estndar ya contienen una biblioteca matemtica para
  simplificacin simblica ode funciones de base algebrica. Nombres
  cualquiera tales como <verbatim|x> con tratados como variables simblicas
  independientes, y no son evaluadas por defecto.

  <\session|yacas|default>
    <\input|yacas] >
      0+x;
    </input>

    <\output>
      <\with|mode|math>
        x
      </with>
    </output>

    <\input|yacas] >
      x+1*y;
    </input>

    <\output>
      <\with|mode|math>
        x+y
      </with>
    </output>

    <\input|yacas] >
      Sin(ArcSin(alpha))+ArcCos(Cos(beta));
    </input>

    <\output>
      <\with|mode|math>
        \<alpha\>+\<beta\>
      </with>
    </output>

    <\input|yacas] >
      (x+y)^3-(x-y)^3
    </input>

    <\output>
      <\with|mode|math>
        <left|(>x+y<right|)><rsup|3>-<left|(>x-y<right|)><rsup|3>
      </with>
    </output>

    <\input|yacas] >
      Simplify(%)
    </input>

    <\output>
      <\with|mode|math>
        6x<rsup|2>y+2y<rsup|3>
      </with>
    </output>

    \;
  </session>

  El operador especial <verbatim|%> automticamente recuerda el resultado de
  la lnea previa. La funcin <verbatim|Simplify> intenta reducir una
  expresin a su forma ms simple. Note que las nombres de las funciones
  estndar en <name|Yacas> inician tpicamente con maysculas. Maysculas
  mltiples como <with|font family|tt|ArcSin> son usadas algunas veces. El
  caracter guin abajo <verbatim|_> es un smbolo de operador reservado y no
  puede ser parte del nombre de una variable o funcin.

  <name|Yacas> puede tratar con nmeros de precisin arbitraria:

  <\session|yacas|default>
    <\input|yacas] >
      20!;
    </input>

    <\output>
      <\with|mode|math>
        2432902008176640000
      </with>
    </output>

    \;
  </session>

  Cuando trate con nmeros de punto flotante, el comando <with|font
  family|tt|Precision(n);> puede ser usado para especificar que todos los
  nmeros de punto flotante deben tener una precisin fija de <verbatim|n>
  dgitos:

  <\session|yacas|default>
    <\input|yacas] >
      Precision(30);
    </input>

    <\output>
      <\with|mode|math>
        <with|math font family|rm|True >
      </with>
    </output>

    <\input|yacas] >
      N(1/243);
    </input>

    <\output>
      <\with|mode|math>
        0.004115226337448559670781893004
      </with>
    </output>

    \;
  </session>

  Note que necesitamos entrar <with|font family|tt|N()> para forzar el
  clculo aproximado, de otro modo la fraccin habra sido dejada sin
  evaluar. El valor <verbatim|True> es una constante booleana.

  Derivadas analticas de funciones pueden ser evaluadas:

  <\session|yacas|default>
    <\input|yacas] >
      D(x) Sin(x);
    </input>

    <\output>
      <\with|mode|math>
        cos x
      </with>
    </output>

    <\input|yacas] >
      D(x) D(x) Sin(x);
    </input>

    <\output>
      <\with|mode|math>
        -sin x
      </with>
    </output>

    \;
  </session>

  Los nmeros racionales permanecern racionales tanto como el numerados y el
  denominador sean enteros, as <verbatim|55/10> ser evaluado a
  <verbatim|11/2>. Puede sobre escribir este comportamiento usando la funcin
  de evaluacin numrica <with|font series|bold|<with|font family|tt|N()>>.
  Por ejemplo <with|font series|bold|<with|font family|tt|N(55/10)>> se
  evaluar como <verbatim|5.5> . Este comportamiento se mantiena para la
  mayora de las funciones matemticas. <name|Yacas> tratar de mantener la
  respuesta exacta (en trminos de enteros o fracciones) en lugar de usar
  nmeros de punto flotante, a menos que <verbatim|N()> sea usado. Donde el
  valor para la constante <with|mode|math|\<pi\>> sea necesario, use la
  variable preconstruida <verbatim|Pi>. Puede ser reemplazado por el valor
  numrico (aproximado) cuando <with|font family|tt|N(Pi)> sea llamado.
  <name|Yacas> conoce algunas reglas de simplificacin usando <verbatim|Pi>
  (especialmente con funciones trigonomtricas). La unidad imaginaria
  <with|mode|math|\<mathi\>> es denotada por <verbatim|I> y los nmeros
  complejos pueden ser ingredaso \ bien como expresiones involucrando
  <verbatim|I> o explcitamente como <verbatim|Complex(a,b)> para
  <with|mode|math|a+\<mathi\>**b>.

  Algunos algoritmos de resolucin de ecuaciones sencillas estn en su lugar:

  <\session|yacas|default>
    <\input|yacas] >
      Solve(a+x*y==z,x);
    </input>

    <\output>
      <\with|mode|math>
        <frac|z-a|y>
      </with>
    </output>

    <\input|yacas] >
      Solve({11*x+3*y==1,2*x+y==0},{x,y})
    </input>

    <\output>
      <\with|mode|math>
        <left|(><expand|tabular*|<tformat|<cwith|1|-1|1|1|cell
        halign|c>|<cwith|1|-1|2|2|cell halign|c>|<table|<row|<cell|<frac|1|5>>|<cell|<frac|-2|5>>>>>><right|)>
      </with>
    </output>

    \;
  </session>

  (Note el uso del operador <verbatim|==>, que no evalua a nada, es para
  denotar un objeto "ecuacin"). Actualmente <verbatim|Solve> es ms bien
  limitado y slo trata con ecuaciones donde la variable a ser resuelta slo
  ocurre una vez en la ecuacin. En el futuro habrn algoritmos ms
  sofisticados.

  Las series de Taylor son soportadas, por ejemplo:

  <\session|yacas|default>
    <\input|yacas] >
      Taylor(x,0,3) Exp(x)
    </input>

    <\output>
      <\with|mode|math>
        x+<frac|x<rsup|2>|2>+<frac|x<rsup|3>|6>+1
      </with>
    </output>

    \;
  </session>

  En esta forma la respuesta puede ser un poco dificil de leer, si usted est
  en la interface de comandos, podra entonces teclear

  <\code>
    In\<gtr\> PrettyForm(%);

    \ \ \ \ \ \ \ \ / 1 \\ \ \ \ 2 \ \ / 1 \\ \ \ \ 3

    1 + x + \| - \| * x \ + \| - \| * x

    \ \ \ \ \ \ \ \ \\ 2 / \ \ \ \ \ \ \ \\ 6 /

    \;

    Out\<gtr\> True;
  </code>

  La funcin <with|font family|tt|PrettyForm()> trata de mostrar la frmula
  en el mejor formato para la lectura, usando texto ASCII. Puede tambin
  exportar una expresin a <TeX> tecleando <with|font
  family|tt|TeXForm(...)>.

  <inactive|<label|c1s5>>

  <\section>
    <value|hrule>

    Variables
  </section>

  <name|Yacas> soporta variables:

  <\session|yacas|default>
    <\input|yacas] >
      Set(a,Cos(0));
    </input>

    <\output>
      <\with|mode|math>
        <with|math font family|rm|True >
      </with>
    </output>

    <\input|yacas] >
      a:=a+1;
    </input>

    <\output>
      <\with|mode|math>
        2
      </with>
    </output>

    \;
  </session>

  The variable <with|font series|bold|<with|font family|tt|a>> has now been
  globally set to 2. The function <with|font series|bold|<with|font
  family|tt|Set()>> and the operator <with|font series|bold|<with|font
  family|tt|:=>> can both be used to assign values to global variables.
  (Variables local to procedures can also be defined; see below the chapters
  on programming.) To clear a variable binding, execute <with|font
  series|bold|<with|font family|tt|Clear(a);>> "<with|font
  series|bold|<with|font family|tt|a>>" will now evaluate to just <with|font
  series|bold|<with|font family|tt|a>>. This is one of the properties of the
  evaluation scheme of <with|font series|bold|<with|font family|tt|Yacas>>:
  when some object can not be evaluated or transformed any further, it is
  returned as the final result.

  La variable <var|a> ahora ha sido globalmente configurada como 2. La
  funcin <with|font family|tt|Set()> y el operador <verbatim|:=> pueden
  ambos ser usados para asignar valores a las variables globales. (Las
  variales locales a los procedimientos tambin pueden ser definidas; vea
  luego los captulos sobre programacin.) Para limpiar un enlace a una
  variable, ejecute \ <with|font series|bold|<with|font family|tt|Clear(a);>>
  "<with|font series|bold|<with|font family|tt|a>>" ahora se valuar slo
  como <verbatim|a>. Esta es una de las propiedades del esquema de evaluacin
  de <name|Yacas>: Cuando un objeto no puede ser evaluado o transformado ms,
  es retornado como un resultado final.

  Actualmente no hay diferencia entre asignar varialbes suando
  <verbatim|Set()> o usar el operador <with|font series|bold|<with|font
  family|tt|:=>>. El ltimo puede sin embargo asignar listas y definir
  funciones.

  <inactive|<label|c1s6>>

  <\section>
    <value|hrule>

    Funciones
  </section>

  El operador <verbatim|:=> puede ser usado para definir funciones:

  <\code>
    f(x):=2*x*x
  </code>

  definir una nueva funcin <verbatim|f>, que acepta un argumento y retorna
  el doble del cuadrado del argumento.

  Uno y el mismo nombre de funcin <verbatim|f> puede ser usado por
  diferentes funciones si ellas toman diferente nmero de argumentos (pero no
  si ellas slamente toman diferentes <em|tipos> de argumentos, puesto que
  <name|Yacas> no tiene un sistema de tipos estricto):

  <\session|yacas|default>
    <\input|yacas] >
      f(x):=x^2;
    </input>

    <\output>
      <\with|mode|math>
        <with|math font family|rm|True >
      </with>
    </output>

    <\input|yacas] >
      f(x,y):=x*y;
    </input>

    <\output>
      <\with|mode|math>
        <with|math font family|rm|True >
      </with>
    </output>

    <\input|yacas] >
      f(3)+f(3,2);
    </input>

    <\output>
      <\with|mode|math>
        15
      </with>
    </output>

    \;
  </session>

  Functions may return values of any type, or may even return values of
  different types at different times.

  Las funciones pueden retornar valores de cualquier tipo, o incluso pueden
  retornar diferentes tipos en diferentes ocaciones.

  <name|Yacas> predefine <with|font series|bold|<with|font family|tt|True>> y
  <with|font series|bold|<with|font family|tt|False>> como valores booleanos.
  Las funciones que retornan valores booleanos son llamadas <em|predicados>.
  Por ejemplo <with|font series|bold|<with|font family|tt|IsNumber()>> y
  <with|font series|bold|<with|font family|tt|IsInteger()>> son predicados
  definidos en la biblioteca estndar:

  <\session|yacas|default>
    <\input|yacas] >
      IsNumber(2+x);
    </input>

    <\output>
      <\with|mode|math>
        <with|math font family|rm|False >
      </with>
    </output>

    <\input|yacas] >
      IsInteger(15/5);
    </input>

    <\output>
      <\with|mode|math>
        <with|math font family|rm|True >
      </with>
    </output>

    \;
  </session>

  Cuando se asignan variables, el lado derecho es evaluado antes de ser
  asignado. as

  <\code>
    a:=2*2
  </code>

  will set <with|font series|bold|<with|font family|tt|a>> to 4. This is
  however <with|font shape|italic|not> the case for functions. When entering
  <with|font series|bold|<with|font family|tt|f(x):=x+x>> the right hand
  side, <with|font series|bold|<with|font family|tt|x+x>>, is not evaluated
  before being assigned. This can be forced by using <with|font
  series|bold|<with|font family|tt|Eval()>>:

  configurar <verbatim|a> a <verbatim|4>. Este <em|no> es sin embargo el
  caso para las funciones. Cuando entra <with|font family|tt|f(x):=x+x> el
  lado derecho, <with|font family|tt|x+x>, no es evaluado antes de ser
  asignado. Esto puede ser forzado usando <verbatim|Eval()>:

  <\code>
    f(x):=Eval(x+x)
  </code>

  primero evaluar <with|font series|bold|<with|font family|tt|x+x>> a
  <with|font series|bold|<with|font family|tt|2*x>> antes de asignarlo a la
  funcin de usuario <verbatim|f>. Este ejemplo especfico no es uno muy
  til, pero vendr al lugar cuando la operacin realizada en la derecha sea
  costosa. Por ejemplo, si evaluamos la expansin en series de Taylor antes
  de asignarla a la funcin definida por el usuario, el motor no necesita
  crear una expansin en series de Taylor cada vez que la funcin definida
  por el usuario es llamada.

  <inactive|<label|c1s7>>

  <\section>
    <value|hrule>

    Cadenas y listas
  </section>

  En adicin a los nmeros y variables, <name|Yacas> soporta cadenas y
  listas. Las cadenas son secuencias simples de caracteres encerrador por
  comillas dobles, por ejemplo:

  <\code>
    "this is a string with \\"quotes\\" in it"
  </code>

  Las listas son grupos ordenados de itemas, como es usual. <name|Yacas>
  representa las listas poniendo los objetos entre llaves y separndolos por
  comas. Las listas consistentes de objetos <with|font series|bold|<with|font
  family|tt|a>>, <with|font series|bold|<with|font family|tt|b>>, y
  <with|font series|bold|<with|font family|tt|c>> pueden ser ingresadas
  tecleando <with|font series|bold|<with|font family|tt|{a,b,c}>>. En
  <name|Yacas>, los vectores son representados como listas y las matrices son
  listas de listas. De hecho, cualquier expresin <name|Yacas> puede ser
  converdida en una lista (ver despus)

  Los items en una lista pueden ser accedidos a travs del operador
  <with|font series|bold|<with|font family|tt|[ ]>>. Ejemplos: cuando ingresa

  <\code>
    uu:={a,b,c,d,e,f};
  </code>

  entonces

  <\code>
    uu[2];
  </code>

  se evalua como <verbatim|b>, y

  <\code>
    uu[2 .. 4];
  </code>

  se evalua como <with|font series|bold|<with|font family|tt|{b,c,d}>>. La
  expresin de "rango"

  <\code>
    2 .. 4
  </code>

  se evalua como <with|font series|bold|<with|font family|tt|{2,3,4}>>. Notue
  que los espacios alrededor del operador <verbatim|..> son necesarios, o si
  no el analizador gramaticas son ser capaz de distinguirlo de una parte de
  un nmero.

  Otro uso de las listas es las listas asociativas, algunas veces llamadas
  una tabla de hash, que es implementada en <name|Yacas> simplementa como una
  lista de pares llave-valor. La llave debe ser cadenas y los valores pueden
  ser cualquier objeto. Las listas asosiativas pueden tambin trabajar como
  mini-bases de datos. Como ejemplo, primero ingrese

  <\session|yacas|default>
    <\input|yacas] >
      u:={};
    </input>

    <\output>
      CommandLine(1) : Invalid argument
    </output>

    \;
  </session>

  y luego

  <\session|yacas|default>
    <\input|yacas] >
      u["nombre"] := "Isaias"
    </input>

    <\output>
      <\with|mode|math>
        <with|math font family|rm|True >
      </with>
    </output>

    <\input|yacas] >
      u["ocupacion"] := "profeta";
    </input>

    <\output>
      <\with|mode|math>
        <with|math font family|rm|True >
      </with>
    </output>

    <\input|yacas] >
      u["esta vivo"]:=False;
    </input>

    <\output>
      <\with|mode|math>
        <with|math font family|rm|True >
      </with>
    </output>

    \;
  </session>

  Ahora, <verbatim|u["nombre"]> debera retornar <verbatim|"Isaias">. La
  lista <verbatim|u> ahora contiene tres sublistas, como podemos ver:

  <\session|yacas|default>
    <\input|yacas] >
      u;
    </input>

    <\output>
      <\with|mode|math>
        <left|(><expand|tabular*|<tformat|<cwith|1|-1|1|1|cell
        halign|c>|<cwith|1|-1|2|2|cell halign|c>|<table|<row|<cell|<with|math
        font family|rm|esta vivo>>|<cell|<with|math font family|rm|False
        >>>|<row|<cell|<with|math font family|rm|ocupacion>>|<cell|<with|math
        font family|rm|profeta>>>|<row|<cell|<with|math font
        family|rm|nombre>>|<cell|<with|math font
        family|rm|Isaias>>>>>><right|)>
      </with>
    </output>

    \;
  </session>

  Las listas evaluan sus argumentos, y retornan una lista con resultados de
  la evaluacin de cada elemento. As, teclear <with|font
  series|bold|<with|font family|tt|{1+2,3};>> se evaluara como <with|font
  series|bold|<with|font family|tt|{3,3}>>.

  La asignacin de mltiples variables es tambin posible usando listas. Por
  ejemplo, <with|font series|bold|<with|font family|tt|{x,y}:={2!,3!}>>
  resultar en 2 siendo asociado a <var|x> y 6 a <var|y>.

  La idea de usar listas para representar expresiones data desde el lenguaje
  LISP desarrollado en 1970. De un pequeo conjunto de operaciones sobre
  listas, algoritmos de manipulacin simblica muy poderosos pueden ser
  construidos. Las listas tambin pueden ser usadas como argumentos de
  funciones cuando un nmero variable de argumentos son esperados.

  Probemos algunas operaciones sobre listas ahora:

  <\session|yacas|default>
    <\input|yacas] >
      Clear(a); // primero limpiamos la variable a de las asignaciones
      previas en este documento
    </input>

    <\output>
      <\with|mode|math>
        <with|math font family|rm|True >
      </with>
    </output>

    <\input|yacas] >
      m := {a,b,c};
    </input>

    <\output>
      <\with|mode|math>
        <left|(>a,b,c<right|)>
      </with>
    </output>

    <\input|yacas] >
      Length(m);
    </input>

    <\output>
      <\with|mode|math>
        3
      </with>
    </output>

    <\input|yacas] >
      Reverse(m);
    </input>

    <\output>
      <\with|mode|math>
        <with|math font family|rm|Reverse
        ><left|(><expand|tabular*|<tformat|<cwith|1|-1|1|1|cell
        halign|c>|<cwith|1|-1|2|2|cell halign|c>|<cwith|1|-1|3|3|cell
        halign|c>|<table|<row|<cell|a>|<cell|b>|<cell|c>>>>><right|)>
      </with>
    </output>

    <\input|yacas] >
      Concat(m,m);
    </input>

    <\output>
      <\with|mode|math>
        <left|(>a,b,c,a,b,c<right|)>
      </with>
    </output>

    <\input|yacas] >
      m[1] := "blah blah";
    </input>

    <\output>
      <\with|mode|math>
        <with|math font family|rm|True >
      </with>
    </output>

    <\input|yacas] >
      m;
    </input>

    <\output>
      <\with|mode|math>
        <left|(><with|math font family|rm|blah blah>,b,c<right|)>
      </with>
    </output>

    <\input|yacas] >
      Nth(m,2);
    </input>

    <\output>
      <\with|mode|math>
        b
      </with>
    </output>

    \;
  </session>

  Ms operaciones de listas son descritas en el manual de referencia.

  <inactive|<label|c1s8>>

  <\section>
    <value|hrule>

    lgebra Lineal
  </section>

  Los vectores de dimensin fija son representados como listas de sus
  componentes. La lista {1,2,3} sera un vector tridimensional con
  componentes 1, 2 y 3. Las matrices son representadas como vectores de
  vectores.

  Vector components can be assigned values just like list items, since they
  are in fact list items:

  A los componentes de los vectores les pueden ser asignados valores justo
  como los items de la listas, puesto que ellos son de hecho items de listas:

  <\session|yacas|default>
    <\input|yacas] >
      l:=ZeroVector(3);
    </input>

    <\output>
      <\with|mode|math>
        <left|(>0,0,0<right|)>
      </with>
    </output>

    <\input|yacas] >
      l[ 2 ]:=2;
    </input>

    <\output>
      <\with|mode|math>
        <with|math font family|rm|True >
      </with>
    </output>

    <\input|yacas] >
      l;
    </input>

    <\output>
      <\with|mode|math>
        <left|(>0,2,0<right|)>
      </with>
    </output>

    \;
  </session>

  <name|Yacas> puede realizar multiplicacin de matrices, vectores y nmeros
  como es usual en lgebra lineal:

  <\session|yacas|default>
    <\input|yacas] >
      v:={1,0,0,0}
    </input>

    <\output>
      <\with|mode|math>
        <left|(>1,0,0,0<right|)>
      </with>
    </output>

    <\input|yacas] >
      E4:={{0,u1,0,0},{d0,0,u2,0},{0,d1,0,0},{0,0,d2,0}}
    </input>

    <\output>
      <\with|mode|math>
        <left|(><expand|tabular*|<tformat|<cwith|1|-1|1|1|cell
        halign|c>|<cwith|1|-1|2|2|cell halign|c>|<cwith|1|-1|3|3|cell
        halign|c>|<cwith|1|-1|4|4|cell halign|c>|<table|<row|<cell|0>|<cell|u<rsub|1>>|<cell|0>|<cell|0>>|<row|<cell|d<rsub|0>>|<cell|0>|<cell|u<rsub|2>>|<cell|0>>|<row|<cell|0>|<cell|d<rsub|1>>|<cell|0>|<cell|0>>|<row|<cell|0>|<cell|0>|<cell|d<rsub|2>>|<cell|0>>>>><right|)>
      </with>
    </output>

    <\input|yacas] >
      CharacteristicEquation(E4,x)
    </input>

    <\output>
      <\with|mode|math>
        x<rsup|4>-x*u<rsub|2>d<rsub|1>x-u<rsub|1>d<rsub|0>x<rsup|2>
      </with>
    </output>

    <\input|yacas] >
      Expand(%,x)
    </input>

    <\output>
      <\with|mode|math>
        x<rsup|4>-<left|(>u<rsub|2>d<rsub|1>+u<rsub|1>d<rsub|0><right|)>x<rsup|2>
      </with>
    </output>

    <\input|yacas] >
      v+E4*v+E4*E4*v+E4*E4*E4*v
    </input>

    <\output>
      <\with|mode|math>
        <left|(>u<rsub|1>d<rsub|0>+1,d<rsub|0>+<left|(>d<rsub|0>u<rsub|1>+u<rsub|2>d<rsub|1><right|)>d<rsub|0>,d<rsub|1>d<rsub|0>,d<rsub|2>d<rsub|1>d<rsub|0><right|)>
      </with>
    </output>

    \;
  </session>

  La biblioteca estndar de <em|scripts> de <name|Yacas> tambin incluye
  sacar el determinante de una matriz, encontrar eigenvectores y eigenvalores
  (en casos simples) y resolver conjuntos lienales de ecuaciones, tales como
  <with|mode|math|A*x=b> donde <with|mode|math|A> es una matriz, y
  <with|mode|math|x> y <with|mode|math|b> con vectores. Hay varias
  operaciones ms de matrices soportadas. Vea el manual de referencia para
  ms detalles.

  <inactive|<label|c1s9>>

  <\section>
    <value|hrule>

    Control de flujo: condicionales, ciclos, bloques
  </section>

  El lenguaje <name|Yacas> incluye algunos constructor y funciones para el
  control de flujo. Los ciclos pueden ser hechos bien con una llamade de
  funcin de un <with|font family|tt|ForEach()> o con un <with|font
  series|bold|<with|font family|tt|While()>>. La funcin <with|font
  series|bold|<with|font family|tt|ForEach(x, lista) cuerpo>> ejecuta su
  cuerpo para cada elemento de la lista y asigna la variable <var|x> a ese
  elemento cada vez. La llamada de funcin <with|font series|bold|<with|font
  family|tt|While(predicado) cuerpo>> repite el "cuerpo" hasta que el
  "predicado" retorne <with|font series|bold|<with|font family|tt|False>>.

  La ejecucin condicional es implementada por la llamada de funcin
  <verbatim|If(predicado, cuerpo1, cuerpo2)>, que trabaja como el constructo
  del lenguaje C <with|font series|bold|<with|font family|tt|(predicate) ?
  body1 : body2>>. Si la condicin es verdadera, "cuerpo1" es evaluadoa, de
  otro modo "cuerpo2" es evaluado, y el valor correspondiente es retornado.
  Por ejemplo, el valor absoluto de un nmero puede ser calculado con:

  <\code>
    absx := If( x\<gtr\>=0, x, -x );
  </code>

  (La funcin de biblioteca <with|font family|tt|Abs()> hace esto ya.)

  Si varias operaciones necesitan ser ejecutadas en una secuencia para
  obtener un resultado, puede usar una llamada de funcin <with|font
  series|bold|<with|font family|tt|Prog()>> \ o equivalentemente el
  constructo <with|font series|bold|<with|font family|tt|[ ]>>.\ 

  Para ilustrar estas cacatersticas, creemos una lista de todos los enteros
  pares desde 2 hasta 20 y calculesmos el producto de todos esos enteros,
  exepcto aquellos que son divisibles por 3. (Lo que sigue no es
  necesariamente la forma ms econmica de hacerlo en <name|Yacas>).

  <\session|yacas|default>
    <\input|yacas] >
      L:={};
    </input>

    <\output>
      CommandLine(1) : Invalid argument
    </output>

    <\input|yacas] >
      i := 2;
    </input>

    <\output>
      <\with|mode|math>
        2
      </with>
    </output>

    <\input|yacas] >
      While(i\<less\>=20) [ L:= Append(L, i); i := i+2; ]
    </input>

    <\output>
      <\with|mode|math>
        <with|math font family|rm|True >
      </with>
    </output>

    <\input|yacas] >
      L;
    </input>

    <\output>
      <\with|mode|math>
        <left|(>2,4,6,8,10,12,14,16,18,20<right|)>
      </with>
    </output>

    <\input|yacas] >
      answer := 1;
    </input>

    <\output>
      <\with|mode|math>
        1
      </with>
    </output>

    <\input|yacas] >
      ForEach(i, L) If (Mod(i, 3)!=0, answer := answer * i);
    </input>

    <\output>
      <\with|mode|math>
        <with|math font family|rm|True >
      </with>
    </output>

    <\input|yacas] >
      answer;
    </input>

    <\output>
      <\with|mode|math>
        2867200
      </with>
    </output>

    \;
  </session>

  Usamos una forma ms corta de <verbatim|If(predicado, cuerpo)> con slo un
  cuerpo el cual es ejecutado cuando la condicin se mantiene. Si la
  condicin no se mantiene, este llamado de funcin retorna <with|font
  series|bold|<with|font family|tt|False>>.

  \;
</body>

<\initial>
  <\collection>
    <associate|paragraph width|150mm>
    <associate|odd page margin|5mm>
    <associate|page medium|automatic>
    <associate|page right margin|5mm>
    <associate|page top margin|5mm>
    <associate|reduction page right margin|25mm>
    <associate|reduction page bottom margin|15mm>
    <associate|even page margin|5mm>
    <associate|reduction page left margin|25mm>
    <associate|page height|956160unit>
    <associate|page bottom margin|5mm>
    <associate|reduction page top margin|15mm>
    <associate|page width|1272320unit>
    <associate|language|spanish>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|toc-10|<tuple|<uninit>|?>>
    <associate|c1|<tuple|<uninit>|?>>
    <associate|toc-1|<tuple|<uninit>|?>>
    <associate|c1s1|<tuple|<uninit>|?>>
    <associate|c1s2|<tuple|<uninit>|?>>
    <associate|toc-2|<tuple|<uninit>|?>>
    <associate|c1s3|<tuple|<uninit>|?>>
    <associate|toc-3|<tuple|<uninit>|?>>
    <associate|toc-4|<tuple|<uninit>|?>>
    <associate|c1s4|<tuple|<uninit>|?>>
    <associate|toc-5|<tuple|<uninit>|?>>
    <associate|c1s5|<tuple|<uninit>|?>>
    <associate|toc-6|<tuple|<uninit>|?>>
    <associate|c1s6|<tuple|<uninit>|?>>
    <associate|toc-7|<tuple|<uninit>|?>>
    <associate|c1s7|<tuple|<uninit>|?>>
    <associate|c1s8|<tuple|<uninit>|?>>
    <associate|toc-8|<tuple|<uninit>|?>>
    <associate|c1s9|<tuple|<uninit>|?>>
    <associate|toc-9|<tuple|<uninit>|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <vspace*|1fn><with|font series|<quote|bold>|math font
      series|<quote|bold>|Iniciar con <with|font
      shape|<quote|small-caps>|Yacas>><value|toc-dots><pageref|toc-1><vspace|0.5fn>

      <format|no first indentation><tformat|<tformat|<cwith|1|-1|1|-1|cell
      tborder|1ln>|<twith|table width|1par>|<cwith|1|-1|1|-1|cell
      vmode|exact>|<cwith|1|-1|1|-1|cell height|1ln>|<cwith|1|-1|1|-1|cell
      lsep|0fn>|<cwith|1|-1|1|-1|cell rsep|0fn>|<cwith|1|-1|1|-1|cell
      bsep|0fn>|<cwith|1|-1|1|-1|cell tsep|0fn>|<cwith|1|-1|1|-1|cell
      vcorrect|n>|<table|<row|<cell|<space|1fn|0ln|1ln>>>>>>

      Introduccin<value|toc-dots><pageref|toc-2>

      <format|no first indentation><tformat|<tformat|<cwith|1|-1|1|-1|cell
      tborder|1ln>|<twith|table width|1par>|<cwith|1|-1|1|-1|cell
      vmode|exact>|<cwith|1|-1|1|-1|cell height|1ln>|<cwith|1|-1|1|-1|cell
      lsep|0fn>|<cwith|1|-1|1|-1|cell rsep|0fn>|<cwith|1|-1|1|-1|cell
      bsep|0fn>|<cwith|1|-1|1|-1|cell tsep|0fn>|<cwith|1|-1|1|-1|cell
      vcorrect|n>|<table|<row|<cell|<space|1fn|0ln|1ln>>>>>>

      Instalar <with|font shape|<quote|small-caps>|Yacas><value|toc-dots><pageref|toc-3>

      <format|no first indentation><tformat|<tformat|<cwith|1|-1|1|-1|cell
      tborder|1ln>|<twith|table width|1par>|<cwith|1|-1|1|-1|cell
      vmode|exact>|<cwith|1|-1|1|-1|cell height|1ln>|<cwith|1|-1|1|-1|cell
      lsep|0fn>|<cwith|1|-1|1|-1|cell rsep|0fn>|<cwith|1|-1|1|-1|cell
      bsep|0fn>|<cwith|1|-1|1|-1|cell tsep|0fn>|<cwith|1|-1|1|-1|cell
      vcorrect|n>|<table|<row|<cell|<space|1fn|0ln|1ln>>>>>>

      Usando el modo de consola y el modo
      T<rsub|<space|-0.4spc><move|<resize|<with|index
      level|<quote|0>|E>||||0.5fn|>|0fn|-0.1fn>><space|-0.4spc>X<rsub|<space|-0.4spc><move|<resize|M<space|-0.2spc>A<space|-0.4spc>CS||||0.5fn|>|0fn|-0.1fn>><value|toc-dots><pageref|toc-4>

      <format|no first indentation><tformat|<tformat|<cwith|1|-1|1|-1|cell
      tborder|1ln>|<twith|table width|1par>|<cwith|1|-1|1|-1|cell
      vmode|exact>|<cwith|1|-1|1|-1|cell height|1ln>|<cwith|1|-1|1|-1|cell
      lsep|0fn>|<cwith|1|-1|1|-1|cell rsep|0fn>|<cwith|1|-1|1|-1|cell
      bsep|0fn>|<cwith|1|-1|1|-1|cell tsep|0fn>|<cwith|1|-1|1|-1|cell
      vcorrect|n>|<table|<row|<cell|<space|1fn|0ln|1ln>>>>>>

      <with|font shape|<quote|small-caps>|Yacas> as a symbolic
      calculator<value|toc-dots><pageref|toc-5>

      <format|no first indentation><tformat|<tformat|<cwith|1|-1|1|-1|cell
      tborder|1ln>|<twith|table width|1par>|<cwith|1|-1|1|-1|cell
      vmode|exact>|<cwith|1|-1|1|-1|cell height|1ln>|<cwith|1|-1|1|-1|cell
      lsep|0fn>|<cwith|1|-1|1|-1|cell rsep|0fn>|<cwith|1|-1|1|-1|cell
      bsep|0fn>|<cwith|1|-1|1|-1|cell tsep|0fn>|<cwith|1|-1|1|-1|cell
      vcorrect|n>|<table|<row|<cell|<space|1fn|0ln|1ln>>>>>>

      Variables<value|toc-dots><pageref|toc-6>

      <format|no first indentation><tformat|<tformat|<cwith|1|-1|1|-1|cell
      tborder|1ln>|<twith|table width|1par>|<cwith|1|-1|1|-1|cell
      vmode|exact>|<cwith|1|-1|1|-1|cell height|1ln>|<cwith|1|-1|1|-1|cell
      lsep|0fn>|<cwith|1|-1|1|-1|cell rsep|0fn>|<cwith|1|-1|1|-1|cell
      bsep|0fn>|<cwith|1|-1|1|-1|cell tsep|0fn>|<cwith|1|-1|1|-1|cell
      vcorrect|n>|<table|<row|<cell|<space|1fn|0ln|1ln>>>>>>

      Functions<value|toc-dots><pageref|toc-7>

      <format|no first indentation><tformat|<tformat|<cwith|1|-1|1|-1|cell
      tborder|1ln>|<twith|table width|1par>|<cwith|1|-1|1|-1|cell
      vmode|exact>|<cwith|1|-1|1|-1|cell height|1ln>|<cwith|1|-1|1|-1|cell
      lsep|0fn>|<cwith|1|-1|1|-1|cell rsep|0fn>|<cwith|1|-1|1|-1|cell
      bsep|0fn>|<cwith|1|-1|1|-1|cell tsep|0fn>|<cwith|1|-1|1|-1|cell
      vcorrect|n>|<table|<row|<cell|<space|1fn|0ln|1ln>>>>>>

      Strings and lists<value|toc-dots><pageref|toc-8>

      <format|no first indentation><tformat|<tformat|<cwith|1|-1|1|-1|cell
      tborder|1ln>|<twith|table width|1par>|<cwith|1|-1|1|-1|cell
      vmode|exact>|<cwith|1|-1|1|-1|cell height|1ln>|<cwith|1|-1|1|-1|cell
      lsep|0fn>|<cwith|1|-1|1|-1|cell rsep|0fn>|<cwith|1|-1|1|-1|cell
      bsep|0fn>|<cwith|1|-1|1|-1|cell tsep|0fn>|<cwith|1|-1|1|-1|cell
      vcorrect|n>|<table|<row|<cell|<space|1fn|0ln|1ln>>>>>>

      Linear Algebra<value|toc-dots><pageref|toc-9>

      <format|no first indentation><tformat|<tformat|<cwith|1|-1|1|-1|cell
      tborder|1ln>|<twith|table width|1par>|<cwith|1|-1|1|-1|cell
      vmode|exact>|<cwith|1|-1|1|-1|cell height|1ln>|<cwith|1|-1|1|-1|cell
      lsep|0fn>|<cwith|1|-1|1|-1|cell rsep|0fn>|<cwith|1|-1|1|-1|cell
      bsep|0fn>|<cwith|1|-1|1|-1|cell tsep|0fn>|<cwith|1|-1|1|-1|cell
      vcorrect|n>|<table|<row|<cell|<space|1fn|0ln|1ln>>>>>>

      Control flow: conditionals, loops, blocks<value|toc-dots><pageref|toc-10>
    </associate>
  </collection>
</auxiliary>
