<TeXmacs|1.0.1.14>

<style|browser>

<\body>
  <inactive|<label|c3>>

  <chapter|Let's learn some more>

  <inactive|<label|c3s1>>

  <\section>
    <value|hrule>

    Command-line options
  </section>

  The default operation of <with|font series|bold|<with|font
  family|tt|Yacas>> is to run in the interactive console mode. <with|font
  series|bold|<with|font family|tt|Yacas>> accepts several options that
  modify its operation. Options can be combined, for example, <with|font
  series|bold|<with|font family|tt|yacas -pc>> <with|font
  series|bold|<with|font family|tt|filename>> will execute a file
  non-interactively. Here is a summary of options:

  <\code>
    yacas -c
  </code>

  Inhibit printing of prompts <with|font series|bold|<with|font
  family|tt|In\<gtr\>>> and <with|font series|bold|<with|font
  family|tt|Out\<gtr\>>>. Useful for non-interactive sessions.

  <\code>
    yacas -f
  </code>

  Reads standard input as one file, but executes only the first statement in
  it. (You may want to use a statement block to have several statements
  executed.)

  <\code>
    yacas -p
  </code>

  Does not use terminal capabilities, no fancy editing on the command line
  and no escape sequences printed. Useful for non-interactive sessions.

  <\code>
    yacas -t
  </code>

  Enable some extra history recall functionality in console mode: after
  executing a command from the history list, the next unmodified command from
  the history list will be automatically entered on the command line.

  <\code>
    yacas [options] {filename}
  </code>

  Reads and executes commands in the filename and exits. Equivalent to
  <with|font series|bold|<with|font family|tt|Load()>>.

  <\code>
    yacas -v
  </code>

  Prints version information and exits.

  <\code>
    yacas -d
  </code>

  Prints the path to the <with|font series|bold|<with|font family|tt|Yacas>>
  library directory and exits.

  <\code>
    yacas --patchload
  </code>

  Will load every file on the command line not with the normal Load command,
  but with PatchLoad. This is useful for generating html pages for a web site
  using the <with|font series|bold|<with|font family|tt|Yacas>> scripting
  language, much like you can do with the php scripting language.

  <\code>
    yacas --init [file]
  </code>

  Tells the system to load <with|font series|bold|<with|font family|tt|file>>
  as the initialization file. Otherwise it loads the file <with|font
  series|bold|<with|font family|tt|yacasinit.ys>> from the scripts directory.

  <\code>
    yacas --rootdir [directory]/
  </code>

  Tells the system where to find the library scripts. Here, <with|font
  series|bold|<with|font family|tt|directory/>> is a path that is passed to
  <with|font series|bold|<with|font family|tt|DefaultDirectory>>, and file
  names will be simply appended to it, so you should make sure to include a
  forward or backward slash (depending on the platform) at the end. It is
  also possible to give a list of directories, separated by a colon, eg.
  <with|font series|bold|<with|font family|tt|yacas --rootdir
  scripts/:morescripts/>>.

  <\code>
    yacas --archive [file]
  </code>

  Use a compressed archive instead of the script library.

  <with|font series|bold|<with|font family|tt|Yacas>> has an experimental
  system where files can be compressed into one file, and accessed through
  this command line option. The advantages are:

  <\itemize>
    <item>smaller disk/memory use (useful if <with|font
    series|bold|<with|font family|tt|Yacas>> is used on small hand-held
    computers).

    <item>No problems with directory path separators: "<with|font
    series|bold|<with|font family|tt|path>>/<with|font series|bold|<with|font
    family|tt|file>>" will always resolve to the right file, no matter what
    platform (read: Windows) it runs on.

    <item>The start-up time of the program might improve a little, since a
    smaller file is loaded from disk (disk access being slow), and then
    decompressed in memory, which might be a lot faster than loading from
    disk.
  </itemize>

  An additional savings is due to the fact that the script files are stripped
  from white spaces and comments, making them smaller and faster loading.

  To prepare the compressed library archive, go into the <with|font
  series|bold|<with|font family|tt|ramscripts/>> directory and type

  <\code>
    make -f makefile.compressor
  </code>

  The result should be the archive file <with|font series|bold|<with|font
  family|tt|scripts.dat>>. Then launch <with|font series|bold|<with|font
  family|tt|Yacas>> with the command line option <with|font
  series|bold|<with|font family|tt|--archive scripts.dat>>, with the file
  <with|font series|bold|<with|font family|tt|scripts.dat>> in the current
  directory.

  The reason that the <with|font series|bold|<with|font
  family|tt|scripts.dat>> file is not built automatically is that it is not
  tested, at this time, that the build process works on all platforms.

  When an archive is present, it will be tried before trying to load scripts
  from the library directories. Typing

  <\code>
    make archivetest -f makefile.compressor
  </code>

  in the <with|font series|bold|<with|font family|tt|ramscripts/>> directory
  runs all the test scripts using the archived files.

  The currently supported compression schemes are uncompressed, and
  compressed with <with|font series|bold|<with|font family|tt|minilzo>>.
  Script file stripping (removing whitespace and comments) may be disabled by
  editing <with|font series|bold|<with|font family|tt|compressor.cpp>>
  (variable <with|font series|bold|<with|font family|tt|strip_script>>).

  <label|c3s2>

  <\section>
    <value|hrule>

    Client/server usage
  </section>

  In addition to the console mode, an experimental persistent session
  facility is provided through the script <with|font series|bold|<with|font
  family|tt|yacas_client>>. By means of this script, the user can configure
  third-party applications to pass commands to a constantly running
  "<with|font series|bold|<with|font family|tt|Yacas>> server" and get
  output. The "<with|font series|bold|<with|font family|tt|Yacas>> server" is
  automatically started by <with|font series|bold|<with|font
  family|tt|yacas_client>>. It may run on a remote computer; in that case the
  user should have a user account on the remote computer and privileges to
  execute <with|font series|bold|<with|font family|tt|yacas_client>> there,
  as well as <with|font series|bold|<with|font family|tt|rsh>> or <with|font
  series|bold|<with|font family|tt|ssh>> access. The purpose of <with|font
  series|bold|<with|font family|tt|yacas_client>> is to enable users to pass
  commands to <with|font series|bold|<with|font family|tt|Yacas>> within a
  persistent session while running another application such as a text editor.

  The script <with|font series|bold|<with|font family|tt|yacas_client>> reads
  <with|font series|bold|<with|font family|tt|Yacas>> commands from the
  standard input and passes them to the running "<with|font
  series|bold|<with|font family|tt|Yacas>> server"; it then waits 2 seconds
  and prints whatever output <with|font series|bold|<with|font
  family|tt|Yacas>> produced up to this time. Usage may look like this:

  <\code>
    8:20pm Unix\<gtr\>echo "x:=3" \| yacas_client

    Starting server.

    [editvi] [gnuplot]

    True;

    To exit Yacas, enter \ Exit(); or quit

    \ \ or Ctrl-c. Type ?? for help.

    Or type ?function for help on a function.

    Type 'restart' to restart Yacas.

    To see example commands, keep typing

    \ \ Example();

    In\<gtr\> x:=3

    Out\<gtr\> 3;

    In\<gtr\> 8:21pm Unix\<gtr\>echo "x:=3+x" \| yacas_client

    In\<gtr\> x:=3+x

    Out\<gtr\> 6;

    In\<gtr\> 8:23pm Unix\<gtr\>yacas_client -stop

    In\<gtr\> quit

    Quitting...

    Server stopped.

    8:23pm Unix\<gtr\>
  </code>

  Persistence of the session means that <with|font series|bold|<with|font
  family|tt|Yacas>> remembered the value of <with|font series|bold|<with|font
  family|tt|x>> between invocations of <with|font series|bold|<with|font
  family|tt|yacas_client>>. If there is not enough time for <with|font
  series|bold|<with|font family|tt|Yacas>> to produce output within 2
  seconds, the output will be displayed the next time you call <with|font
  series|bold|<with|font family|tt|yacas_client>>.

  The "<with|font series|bold|<with|font family|tt|Yacas>> server" is started
  automatically when first used and can be stopped either by quitting
  <with|font series|bold|<with|font family|tt|Yacas>> or by an explicit
  option <with|font series|bold|<with|font family|tt|yacas_client -stop>>, in
  which case <with|font series|bold|<with|font family|tt|yacas_client>> does
  not read standard input.

  The script <with|font series|bold|<with|font family|tt|yacas_client>> reads
  standard input and writes to standard output, so it can be used via remote
  shell execution. For example, if an account "user" on a remote computer
  "remote.host" is accessible through <with|font series|bold|<with|font
  family|tt|ssh>>, then <with|font series|bold|<with|font
  family|tt|yacas_client>> can be used remotely, like this:

  <\code>
    echo "x:=2;" \| \\

    \ \ ssh user@remote.host yacas_client
  </code>

  On a given host computer running the "<with|font series|bold|<with|font
  family|tt|Yacas>> server", each user currently may have only one persistent
  <with|font series|bold|<with|font family|tt|Yacas>> session.

  <label|c3s3>

  <\section>
    <value|hrule>

    Compound statements
  </section>

  Multiple statements can be grouped together using the <with|font
  series|bold|<with|font family|tt|[>> and <with|font series|bold|<with|font
  family|tt|]>> brackets. The compound <with|font series|bold|<with|font
  family|tt|[a; b; c;];>> evaluates <with|font series|bold|<with|font
  family|tt|a>>, then <with|font series|bold|<with|font family|tt|b>>, then
  <with|font series|bold|<with|font family|tt|c>>, and returns the result of
  evaluating <with|font series|bold|<with|font family|tt|c>>.

  A variable can be declared local to a compound statement block by the
  function <with|font series|bold|<with|font family|tt|Local(var1,
  var2,...)>>.

  <label|c3s4>

  <\section>
    <value|hrule>

    "Threading" of functions
  </section>

  Some functions in <with|font series|bold|<with|font family|tt|Yacas>> can
  be "threaded". This means that calling the function with a list as argument
  will result in a list with that function being called on each item in the
  list. E.g.

  <\code>
    Sin({a,b,c});
  </code>

  will result in <with|font series|bold|<with|font
  family|tt|{Sin(a),Sin(b),Sin(c)}>>. This functionality is implemented for
  most normal analytic functions and arithmetic operators.

  <label|c3s5>

  <\section>
    <value|hrule>

    Functions as lists
  </section>

  Internally, <with|font series|bold|<with|font family|tt|Yacas>> represents
  all atomic expressions (numbers and variables) as strings and all compound
  expressions as lists, just like LISP. Try <with|font series|bold|<with|font
  family|tt|FullForm(a+b*c);>> and you will see the text "<with|font
  series|bold|<with|font family|tt|(+ a (* b c ))>>" appear on the screen.
  Also, any expression can be converted to a list by the function <with|font
  series|bold|<with|font family|tt|Listify()>> or back to an expression by
  the function <with|font series|bold|<with|font family|tt|UnList()>>:

  <\code>
    In\<gtr\> Listify(a+b*(c+d));

    Out\<gtr\> {+,a,b*(c+d)};

    In\<gtr\> UnList({Atom("+"),x,1});

    Out\<gtr\> x+1;
  </code>

  Note that the first element of the list is the name of the function
  <with|font series|bold|<with|font family|tt|+>> which is equivalently
  represented as <with|font series|bold|<with|font family|tt|Atom("+")>> and
  that the subexpression <with|font series|bold|<with|font
  family|tt|b*(c+d)>> was not converted to list form.

  <with|font shape|italic|Pure functions> are the equivalent of "lambda
  expressions" of LISP; in other words, they are <with|font
  series|bold|<with|font family|tt|Yacas>> expressions representing bodies of
  functions. They are currently implemented using lists and the operator
  <with|font series|bold|<with|font family|tt|Apply()>>. The following line:

  <\code>
    Apply( {{x,y},x+y} , {2,3} );
  </code>

  would evaluate to 5. Here, <with|font series|bold|<with|font
  family|tt|{{x,y},x+y}>> is a list that is treated as a pure function by the
  operator <with|font series|bold|<with|font family|tt|Apply>>, the symbols
  <with|font series|bold|<with|font family|tt|x>> and <with|font
  series|bold|<with|font family|tt|y>> become local variables bound to the
  parameters passed, and <with|font series|bold|<with|font family|tt|x+y>>
  becomes the body of the function.

  <label|c3s6>

  <\section>
    <value|hrule>

    More on syntax
  </section>

  The syntax is handled by an infix grammar parser. Precedence of operations
  can be specified explicitly by parentheses <with|font
  series|bold|<with|font family|tt|( )>> when the normal precedence is not
  what you want. Most of the time you will enter expressions of the form
  <with|font series|bold|<with|font family|tt|Func(var1,var2)>>, or using
  infix operators, <with|font series|bold|<with|font family|tt|a*(b+c)>>,
  prefix operators: <with|font series|bold|<with|font family|tt|-x>>, or
  postfix operators: <with|font series|bold|<with|font family|tt|x++>>. The
  parser is case-sensitive and overall the syntax conventions resemble the C
  language. Last but not least there are the so called "bodied" functions,
  which, unlike normal functions such as <with|font series|bold|<with|font
  family|tt|f(x,y)>>, keep the last argument outside of the bracketed
  argument list: "<with|font series|bold|<with|font family|tt|f(x) y>>". This
  looks somewhat like a mathematical "operator" <with|font series|bold|f(x)>
  acting on <with|font series|bold|y>. A typical example is the function
  <with|font series|bold|<with|font family|tt|While>> which looks like
  "<with|font series|bold|<with|font family|tt|While (predicate) body;>>".
  The derivative operator <with|font series|bold|<with|font family|tt|D(x)>>
  is also defined as a "bodied" function. Note that if we defined a "bodied"
  function <with|font series|bold|<with|font family|tt|A>> with only one
  argument, we would have to use it like this: "<with|font
  series|bold|<with|font family|tt|A() x;>>" and it would look a bit odd. In
  this case we could make "A" a prefix operator and then the syntax would
  become somewhat cleaner: "<with|font series|bold|<with|font family|tt|A
  x;>>"

  However, regardess of presentation, internally all functions and operators
  are equal and merely take a certain number of arguments. The user may
  define or redefine any operators with either "normal" names such as "A" or
  names made of one or more of the special symbols <with|font
  series|bold|<with|font family|tt|+ - * />> <with|font
  series|bold|<with|font family|tt|= \0 ~ :>> <with|font
  series|bold|<with|font family|tt|! @ # $>> <with|font
  series|bold|<with|font family|tt|^ & * _>> <with|font
  series|bold|<with|font family|tt|\| \<less\> \<gtr\>>> and declare them to
  be infix, postfix, or prefix operators, as well as normal or bodied
  functions. (The symbol <with|font series|bold|<with|font family|tt|%>> is
  reserved for the result of the previous expression; the decimal point
  <with|font series|bold|<with|font family|tt|.>> is special and cannot be
  part of an operator's name unless the whole name consists entirely of
  points, e.g. the "<with|font series|bold|<with|font family|tt|..>>"
  operator.) Some of these operators and combinations are already defined in
  <with|font series|bold|<with|font family|tt|Yacas>>'s script library, for
  instance the "syntactic sugar" operators such as <with|font
  series|bold|<with|font family|tt|:=>> or <with|font series|bold|<with|font
  family|tt|\<less\>-->>, but they can be in principle redefined or erased.
  These "special" operators are in no way special to the system, except for
  their syntax.

  All infix, prefix, postfix operators and bodied functions are assigned a
  precedence (an integer number); infix operators in addition have a left and
  a right precedence. All this will only affect the syntax of input and could
  be arranged for the user's convenience. For example, the infix operator
  "<with|font series|bold|<with|font family|tt|*>>" has precedence smaller
  than that of the infix operator "<with|font series|bold|<with|font
  family|tt|+>>", and therefore an expression such as <with|font
  series|bold|<with|font family|tt|a+b*c>> is interpreted in the conventional
  way, i.e. <with|font series|bold|<with|font family|tt|a+(b*c)>>.

  An important caveat is to make sure you always type a space between any
  symbols that could make up an operator. For instance, after you define a
  new function "<with|font series|bold|<with|font family|tt|@@(x):=x^2;>>"
  expressions such as "<with|font series|bold|<with|font
  family|tt|a:=@@(b);>>" typed without spaces will cause an error unless you
  also define the operator "<with|font series|bold|<with|font
  family|tt|:=@@>>". This is because the parser will not stop at "<with|font
  series|bold|<with|font family|tt|:=>>" when trying to make sense of that
  expression. The correct way to deal with this is to insert a space:
  "<with|font series|bold|<with|font family|tt|a:= @@(b)>>". Similarly,
  <with|font series|bold|<with|font family|tt|a!+3>> will cause an error
  unless you define "<with|font series|bold|<with|font family|tt|!+>>", so
  use a space: <with|font series|bold|<with|font family|tt|a! +3>>. Spaces
  are <with|font shape|italic|not> required in situations such as "<with|font
  series|bold|<with|font family|tt|a:=-1>>", but this is so only because the
  operator <with|font series|bold|<with|font family|tt|:=->> is actually
  defined in <with|font series|bold|<with|font family|tt|Yacas>>.

  Let's now have a hands-on primer for these syntactic features. Suppose we
  wanted to define a function <with|font series|bold|F(x,y)=x/y+y/x>. We
  could use the standard syntax:

  <\code>
    In\<gtr\> F(a,b) := a/b + b/a;

    Out\<gtr\> True;
  </code>

  and then use the function as <with|font series|bold|<with|font
  family|tt|F(1,2);>> We might also declare an equivalent infix operation,
  let's call it "<with|font series|bold|<with|font family|tt|xx>>", so that
  we could write simply <with|font series|bold|<with|font family|tt|1 xx 2>>.
  Infix operators must have a precedence, so let's assign it the precedence
  of the usual division operator. The declaration goes as follows:

  <\code>
    In\<gtr\> Infix("xx", OpPrecedence("/"));

    Out\<gtr\> True;

    In\<gtr\> a xx b := a/b + b/a;

    Out\<gtr\> True;

    In\<gtr\> 3 xx 2 + 1;

    Out\<gtr\> 19/6;
  </code>

  Check the math and note how the precedence works!

  We have chosen the name "<with|font series|bold|<with|font family|tt|xx>>"
  just to show that we don't need to use the special characters in the infix
  operator's name. However we must define this operator as infix before using
  it in expressions, or we'd get syntax errors.

  Finally, we might decide to be completely flexible with this important
  function and also define it as a mathematical operator <with|font
  series|bold|<with|font family|tt|##>>. First we define <with|font
  series|bold|<with|font family|tt|##>> as a "bodied" function and then
  proceed as before:

  <\code>
    In\<gtr\> Bodied("##", OpPrecedence("/"));

    Out\<gtr\> True;

    In\<gtr\> ##(a) b := a xx b;

    Out\<gtr\> True;

    In\<gtr\> ##(1) 3 + 2;

    Out\<gtr\> 16/3;
  </code>

  We have used the name <with|font series|bold|<with|font family|tt|##>> but
  we could have used any other name such as <with|font series|bold|<with|font
  family|tt|xx>> or <with|font series|bold|<with|font family|tt|F>> or even
  <with|font series|bold|<with|font family|tt|_-+@+-_>>. Apart from possibly
  confusing yourself, it doesn't matter what you call the functions you
  define.

  There is currently one limitation in <with|font series|bold|<with|font
  family|tt|Yacas>>: once a function name is declared as infix (prefix,
  postfix) or bodied, it will always be interpreted that way. If we declare
  <with|font series|bold|<with|font family|tt|f>> to be "bodied", we may
  later define different functions named <with|font series|bold|<with|font
  family|tt|f>> with different numbers of arguments, however all of these
  functions must be "bodied".

  <label|c3s7>

  <\section>
    <value|hrule>

    Writing simplification rules
  </section>

  Mathematical calculations require versatile transformations on symbolic
  quantities. Instead of trying to define all possible transformations,
  <with|font series|bold|<with|font family|tt|Yacas>> provides a simple and
  easy to use pattern matching scheme for manipulating expressions according
  to user-defined <with|font shape|italic|rules>. <with|font
  series|bold|<with|font family|tt|Yacas>> itself is designed as a small core
  engine executing a large library of rules to match and replace patterns.
  Examples can be found in the library files "standard", "stdfuncs", "deriv"
  and "solve" that come with the <with|font series|bold|<with|font
  family|tt|Yacas>> distribution.

  One simple application of pattern-matching rules is to define new
  functions. (This is actually the only way <with|font series|bold|<with|font
  family|tt|Yacas>> can learn about new functions.) As an example, let's
  define a function <with|font series|bold|<with|font family|tt|f>> that will
  evaluate factorials of non-negative integers. We'll first define a
  predicate to check whether our argument is indeed a non-negative integer,
  and we'll use this predicate and the obvious recursion <with|font
  series|bold|f(n)=n*f(n-1)> to evaluate the factorial. All this is
  accomplished by the following three lines:

  <\code>
    10 # f(0) \<less\>-- 1;

    20 # f(n_IsIntegerGreaterThanZero)

    \ \ \<less\>-- n*f(n-1);

    IsIntegerGreaterThanZero(_n) \<less\>--

    \ \ IsInteger(n) And n\<gtr\>0;
  </code>

  We have first defined two "simplification rules" for a new function
  <with|font series|bold|<with|font family|tt|f()>>. Then we realized that we
  need to define a predicate <with|font series|bold|<with|font
  family|tt|IsIntegerGreaterThanZero()>>. A predicate equivalent to
  <with|font series|bold|<with|font family|tt|IsIntegerGreaterThanZero()>> is
  actually already defined in the standard library and it's called <with|font
  series|bold|<with|font family|tt|IsPositiveInteger>>, so it was not
  necessary, strictly speaking, to define our own predicate to do the same
  thing; we did it here just for illustration.

  The first two lines recursively define a factorial function <with|font
  series|bold|f(n)=n*(n-1)*...*1>. The rules are given precedence values 10
  and 20, so the first rule will be applied first. Incidentally, the
  factorial is also defined in the standard library as a postfix operator
  "<with|font series|bold|<with|font family|tt|!>>" and it is bound to an
  internal routine much faster than the recursion in our example.

  The operator <with|font series|bold|<with|font family|tt|\<less\>-->>
  defines a rule to be applied to a specific function. (The <with|font
  series|bold|<with|font family|tt|\<less\>-->> operation cannot be applied
  to an atom.) The <with|font series|bold|<with|font family|tt|_n>> in the
  rule for <with|font series|bold|<with|font
  family|tt|IsIntegerGreaterThanZero()>> specifies that any object which
  happens to be the argument of that predicate is matched and assigned to the
  local variable <with|font series|bold|<with|font family|tt|n>>. The
  expression to the right of <with|font series|bold|<with|font
  family|tt|\<less\>-->> can use <with|font series|bold|<with|font
  family|tt|n>> (without the underscore) as a variable.

  Now we consider the rules for the function <with|font shape|italic|f>. The
  first rule just specifies that <with|font series|bold|<with|font
  family|tt|f(0)>> should be replaced by 1 in any expression. The second rule
  is a little more involved. <with|font series|bold|<with|font
  family|tt|n_IsIntegerGreaterThanZero>> is a match for the argument of
  <with|font series|bold|<with|font family|tt|f>>, with the proviso that the
  predicate <with|font series|bold|<with|font
  family|tt|IsIntegerGreaterThanZero(n)>> should return <with|font
  series|bold|<with|font family|tt|True>>, otherwise the pattern is not
  matched. The underscore operator is to be used only on the left hand side
  of the rule operator <with|font series|bold|<with|font
  family|tt|\<less\>-->>.

  There is another, slightly longer but equivalent way of writing the second
  rule:

  <\code>
    20 # f(_n)_(IsIntegerGreaterThanZero(n))

    \ \ \<less\>-- n*f(n-1);
  </code>

  The underscore <with|font shape|italic|after> the function object denotes a
  "postpredicate" that should return <with|font series|bold|<with|font
  family|tt|True>> or else there is no match. This predicate may be a
  complicated expression involving several logical operations, unlike the
  simple checking of just one predicate in the <with|font
  series|bold|<with|font family|tt|(n_IsIntegerGreaterThanZero)>> construct.
  The postpredicate can also use the variable <with|font
  series|bold|<with|font family|tt|n>> (without the underscore). Equivalent
  ways of defining the same predicate in rule patterns are simply for
  convenience.

  Precedence values for rules are given by a number followed by the
  <with|font series|bold|<with|font family|tt|#>> operator. This number
  determines the ordering of precedence for the pattern matching rules, with
  0 the lowest allowed precedence value, i.e. rules with precedence 0 will be
  tried first. Multiple rules can have the same number: this just means that
  it doesn't matter what order these patterns are tried in. If no number is
  supplied, 0 is assumed. In our example, the rule <with|font
  series|bold|<with|font family|tt|f(0) \<less\>-- 1>> must be applied
  earlier than the recursive rule, or else the recursion will never
  terminate. But as long as there are no other rules concerning the function
  <with|font series|bold|<with|font family|tt|f>>, the assignment of numbers
  10 and 20 is arbitrary, and they could have been 500 and 501 just as well.

  Predicates can be combined: for example, <with|font series|bold|<with|font
  family|tt|IsIntegerGreaterThanZero()>> could also have been defined as:

  <\code>
    10 # IsIntegerGreaterThanZero(n_IsInteger)

    \ \ _(n\<gtr\>0) \<less\>-- True;

    20 # IsIntegerGreaterThanZero(_n) \<less\>-- False;
  </code>

  The first rule specifies that if <with|font series|bold|<with|font
  family|tt|n>> is an integer, and is greater than zero, the result is
  <with|font series|bold|<with|font family|tt|True>>, and the second rule
  states that otherwise (when the rule with precedence 10 did not apply) the
  predicate returns <with|font series|bold|<with|font family|tt|False>>.

  In the above example, the <with|font series|bold|<with|font
  family|tt|(n\<gtr\>0)>> clause is added after the pattern and allows the
  pattern to match only if this predicate return <with|font
  series|bold|<with|font family|tt|True>>. This is a useful syntax for
  defining rules with complicated predicates. There is no difference between
  the rules <with|font series|bold|<with|font
  family|tt|F(n_IsPositiveInteger)\<less\>--...>> and <with|font
  series|bold|<with|font family|tt|F(_n)_(IsPositiveInteger(n)) \<less\>--
  ...>> except that the first syntax is a little more concise.

  The left hand side of a rule expression has the following form:

  <with|font shape|italic|precedence> <with|font series|bold|<with|font
  family|tt|#>> <with|font shape|italic|pattern> <with|font
  series|bold|<with|font family|tt|_>> <with|font shape|italic|postpredicate>
  <with|font series|bold|<with|font family|tt|\<less\>-->> <with|font
  shape|italic|replacement>.

  The optional <with|font shape|italic|precedence> must be a positive
  integer.

  Some more examples of rules:

  <\code>
    10 # _x + 0 \<less\>-- x;

    20 # _x - _x \<less\>-- 0;

    ArcSin(Sin(_x)) \<less\>-- x;
  </code>

  The last rule has no explicit precedence specified in it (the precedence
  will be assigned automatically by the system).

  <with|font series|bold|<with|font family|tt|Yacas>> will first try to match
  the pattern as a template. Names preceded or followed by an underscore can
  match any one object: a number, a function, a list, etc. <with|font
  series|bold|<with|font family|tt|Yacas>> will assign the relevant variables
  as local variables within the rule, and try the predicates as stated in the
  pattern. The post-predicate (defined after the pattern) is tried after all
  these matched. As an example, the simplification rule <with|font
  series|bold|<with|font family|tt|_x - _x \<less\>--0>> specifies that the
  two objects at left and at right of the minus sign should be the same.

  There is a slightly more complex and general way of defining rules using
  the functions <with|font series|bold|<with|font family|tt|Rule()>>,
  <with|font series|bold|<with|font family|tt|RuleBase()>> and <with|font
  series|bold|<with|font family|tt|RulePattern()>>. However, the standard
  library defines the "<with|font series|bold|<with|font family|tt|... # ...
  \<less\>--...>>" construct which is much more readable and usually
  sufficiently flexible.

  <label|c3s8>

  <\section>
    <value|hrule>

    Local simplification rules
  </section>

  Sometimes you have an expression, and you want to use specific
  simplification rules on it that should not be universally applied. This can
  be done with the <with|font series|bold|<with|font family|tt|/:>> and the
  <with|font series|bold|<with|font family|tt|/::>> operators. Suppose we
  have the expression containing things such as <with|font
  series|bold|<with|font family|tt|Ln(a*b)>>, and we want to change these
  into <with|font series|bold|<with|font family|tt|Ln(a)+Ln(b)>>, the easiest
  way to do this is using the <with|font series|bold|<with|font
  family|tt|/:>> operator as follows:

  <\code>
    In\<gtr\> Sin(x)*Ln(a*b)

    Out\<gtr\> Sin(x)*Ln(a*b);

    In\<gtr\> % /: { Ln(_x*_y) \<less\>- Ln(x)+Ln(y) }

    Out\<gtr\> Sin(x)*(Ln(a)+Ln(b));
  </code>

  A whole list of simplification rules can be built up in the list, and they
  will be applied to the expression on the left hand side of <with|font
  series|bold|<with|font family|tt|/:>>.

  The forms the patterns can have are one of:

  <\code>
    pattern \<less\>- replacement

    pattern , replacement

    pattern , postpredicate , replacement
  </code>

  Note that for these local rules, <with|font series|bold|<with|font
  family|tt|\<less\>->> should be used instead of <with|font
  series|bold|<with|font family|tt|\<less\>-->>. The latter would be used to
  define a "global" rule.

  The <with|font series|bold|<with|font family|tt|/:>> operator traverses an
  expression much like <with|font series|bold|<with|font family|tt|Subst()>>
  does, i.e. top down, trying to apply the rules from the beginning of the
  list of rules to the end of the list of rules. If no rules can be applied
  to the whole expression, it will try the sub-expressions of the expression
  being analyzed.

  It might be sometimes necessary to use the <with|font
  series|bold|<with|font family|tt|/::>> operator, which repeatedly applies
  the <with|font series|bold|<with|font family|tt|/:>> operator until the
  result does not change any more. Caution is required, since rules can
  contradict each other, and that could result in an infinite loop. To detect
  this situation, just use <with|font series|bold|<with|font family|tt|/:>>
  repeatedly on the expression. The repetitive nature should become apparent.

  \;

  \;
</body>

<\initial>
  <\collection>
    <associate|paragraph width|150mm>
    <associate|odd page margin|30mm>
    <associate|page right margin|30mm>
    <associate|page top margin|30mm>
    <associate|reduction page right margin|25mm>
    <associate|reduction page bottom margin|15mm>
    <associate|even page margin|30mm>
    <associate|reduction page left margin|25mm>
    <associate|page bottom margin|30mm>
    <associate|reduction page top margin|15mm>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|c3|<tuple|<uninit>|?>>
    <associate|toc-1|<tuple|<uninit>|?>>
    <associate|c3s1|<tuple|<uninit>|?>>
    <associate|c3s2|<tuple|<uninit>|?>>
    <associate|toc-2|<tuple|<uninit>|?>>
    <associate|c3s3|<tuple|<uninit>|?>>
    <associate|toc-3|<tuple|<uninit>|?>>
    <associate|toc-4|<tuple|<uninit>|?>>
    <associate|c3s4|<tuple|<uninit>|?>>
    <associate|toc-5|<tuple|<uninit>|?>>
    <associate|c3s5|<tuple|<uninit>|?>>
    <associate|toc-6|<tuple|<uninit>|?>>
    <associate|c3s6|<tuple|<uninit>|?>>
    <associate|toc-7|<tuple|<uninit>|?>>
    <associate|c3s7|<tuple|<uninit>|?>>
    <associate|c3s8|<tuple|<uninit>|?>>
    <associate|toc-8|<tuple|<uninit>|?>>
    <associate|toc-9|<tuple|<uninit>|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <vspace*|1fn><with|font series|<quote|bold>|math font
      series|<quote|bold>|Let's learn some
      more><value|toc-dots><pageref|toc-1><vspace|0.5fn>

      <format|no first indentation><tformat|<tformat|<cwith|1|-1|1|-1|cell
      tborder|1ln>|<twith|table width|1par>|<cwith|1|-1|1|-1|cell
      vmode|exact>|<cwith|1|-1|1|-1|cell height|1ln>|<cwith|1|-1|1|-1|cell
      lsep|0fn>|<cwith|1|-1|1|-1|cell rsep|0fn>|<cwith|1|-1|1|-1|cell
      bsep|0fn>|<cwith|1|-1|1|-1|cell tsep|0fn>|<cwith|1|-1|1|-1|cell
      vcorrect|n>|<table|<row|<cell|<space|1fn|0ln|1ln>>>>>>

      Command-line options<value|toc-dots><pageref|toc-2>

      <format|no first indentation><tformat|<tformat|<cwith|1|-1|1|-1|cell
      tborder|1ln>|<twith|table width|1par>|<cwith|1|-1|1|-1|cell
      vmode|exact>|<cwith|1|-1|1|-1|cell height|1ln>|<cwith|1|-1|1|-1|cell
      lsep|0fn>|<cwith|1|-1|1|-1|cell rsep|0fn>|<cwith|1|-1|1|-1|cell
      bsep|0fn>|<cwith|1|-1|1|-1|cell tsep|0fn>|<cwith|1|-1|1|-1|cell
      vcorrect|n>|<table|<row|<cell|<space|1fn|0ln|1ln>>>>>>

      Client/server usage<value|toc-dots><pageref|toc-3>

      <format|no first indentation><tformat|<tformat|<cwith|1|-1|1|-1|cell
      tborder|1ln>|<twith|table width|1par>|<cwith|1|-1|1|-1|cell
      vmode|exact>|<cwith|1|-1|1|-1|cell height|1ln>|<cwith|1|-1|1|-1|cell
      lsep|0fn>|<cwith|1|-1|1|-1|cell rsep|0fn>|<cwith|1|-1|1|-1|cell
      bsep|0fn>|<cwith|1|-1|1|-1|cell tsep|0fn>|<cwith|1|-1|1|-1|cell
      vcorrect|n>|<table|<row|<cell|<space|1fn|0ln|1ln>>>>>>

      Compound statements<value|toc-dots><pageref|toc-4>

      <format|no first indentation><tformat|<tformat|<cwith|1|-1|1|-1|cell
      tborder|1ln>|<twith|table width|1par>|<cwith|1|-1|1|-1|cell
      vmode|exact>|<cwith|1|-1|1|-1|cell height|1ln>|<cwith|1|-1|1|-1|cell
      lsep|0fn>|<cwith|1|-1|1|-1|cell rsep|0fn>|<cwith|1|-1|1|-1|cell
      bsep|0fn>|<cwith|1|-1|1|-1|cell tsep|0fn>|<cwith|1|-1|1|-1|cell
      vcorrect|n>|<table|<row|<cell|<space|1fn|0ln|1ln>>>>>>

      "Threading" of functions<value|toc-dots><pageref|toc-5>

      <format|no first indentation><tformat|<tformat|<cwith|1|-1|1|-1|cell
      tborder|1ln>|<twith|table width|1par>|<cwith|1|-1|1|-1|cell
      vmode|exact>|<cwith|1|-1|1|-1|cell height|1ln>|<cwith|1|-1|1|-1|cell
      lsep|0fn>|<cwith|1|-1|1|-1|cell rsep|0fn>|<cwith|1|-1|1|-1|cell
      bsep|0fn>|<cwith|1|-1|1|-1|cell tsep|0fn>|<cwith|1|-1|1|-1|cell
      vcorrect|n>|<table|<row|<cell|<space|1fn|0ln|1ln>>>>>>

      Functions as lists<value|toc-dots><pageref|toc-6>

      <format|no first indentation><tformat|<tformat|<cwith|1|-1|1|-1|cell
      tborder|1ln>|<twith|table width|1par>|<cwith|1|-1|1|-1|cell
      vmode|exact>|<cwith|1|-1|1|-1|cell height|1ln>|<cwith|1|-1|1|-1|cell
      lsep|0fn>|<cwith|1|-1|1|-1|cell rsep|0fn>|<cwith|1|-1|1|-1|cell
      bsep|0fn>|<cwith|1|-1|1|-1|cell tsep|0fn>|<cwith|1|-1|1|-1|cell
      vcorrect|n>|<table|<row|<cell|<space|1fn|0ln|1ln>>>>>>

      More on syntax<value|toc-dots><pageref|toc-7>

      <format|no first indentation><tformat|<tformat|<cwith|1|-1|1|-1|cell
      tborder|1ln>|<twith|table width|1par>|<cwith|1|-1|1|-1|cell
      vmode|exact>|<cwith|1|-1|1|-1|cell height|1ln>|<cwith|1|-1|1|-1|cell
      lsep|0fn>|<cwith|1|-1|1|-1|cell rsep|0fn>|<cwith|1|-1|1|-1|cell
      bsep|0fn>|<cwith|1|-1|1|-1|cell tsep|0fn>|<cwith|1|-1|1|-1|cell
      vcorrect|n>|<table|<row|<cell|<space|1fn|0ln|1ln>>>>>>

      Writing simplification rules<value|toc-dots><pageref|toc-8>

      <format|no first indentation><tformat|<tformat|<cwith|1|-1|1|-1|cell
      tborder|1ln>|<twith|table width|1par>|<cwith|1|-1|1|-1|cell
      vmode|exact>|<cwith|1|-1|1|-1|cell height|1ln>|<cwith|1|-1|1|-1|cell
      lsep|0fn>|<cwith|1|-1|1|-1|cell rsep|0fn>|<cwith|1|-1|1|-1|cell
      bsep|0fn>|<cwith|1|-1|1|-1|cell tsep|0fn>|<cwith|1|-1|1|-1|cell
      vcorrect|n>|<table|<row|<cell|<space|1fn|0ln|1ln>>>>>>

      Local simplification rules<value|toc-dots><pageref|toc-9>
    </associate>
  </collection>
</auxiliary>
